"""
This type stub file was generated by pyright.
"""

from lockfile.pidlockfile import PIDLockFile

""" Lockfile behaviour implemented via Unix PID files. """
class TimeoutPIDLockFile(PIDLockFile):
    """ Lockfile with default timeout, implemented as a Unix PID file.

        This uses the ``PIDLockFile`` implementation, with the
        following changes:

        * The `acquire_timeout` parameter to the initialiser will be
          used as the default `timeout` parameter for the `acquire`
          method.
        """
    def __init__(self, path, acquire_timeout=..., *args, **kwargs) -> None:
        """ Set up the parameters of a TimeoutPIDLockFile.

            :param path: Filesystem path to the PID file.
            :param acquire_timeout: Value to use by default for the
                `acquire` call.
            :return: ``None``.
            """
        ...
    
    def acquire(self, timeout=..., *args, **kwargs): # -> None:
        """ Acquire the lock.

            :param timeout: Specifies the timeout; see below for valid
                values.
            :return: ``None``.

            The `timeout` defaults to the value set during
            initialisation with the `acquire_timeout` parameter. It is
            passed to `PIDLockFile.acquire`; see that method for
            details.
            """
        ...
    


