"""
This type stub file was generated by pyright.
"""

import pytest
from .embeddings import TextEmbeddingFunction

@pytest.fixture(autouse=True)
def doctest_setup(monkeypatch, tmpdir): # -> None:
    ...

registry = ...
@registry.register("test")
class MockTextEmbeddingFunction(TextEmbeddingFunction):
    """
    Return the hash of the first 10 characters (normalized)
    """
    def generate_embeddings(self, texts): # -> list[ndarray[_Shape, dtype[Any]] | list[int]]:
        ...
    
    def ndims(self): # -> Literal[10]:
        ...
    


@registry.register("nonnorm")
class MockNonNormTextEmbeddingFunction(TextEmbeddingFunction):
    """
    Return the ord of the first 10 characters (not normalized)
    """
    def generate_embeddings(self, texts): # -> list[NDArray[Any] | list[int]]:
        ...
    
    def ndims(self): # -> Literal[10]:
        ...
    


class RateLimitedAPI:
    rate_limit = ...
    last_request_time = ...
    @staticmethod
    def make_request(): # -> Literal['Request successful']:
        ...
    


@registry.register("test-rate-limited")
class MockRateLimitedEmbeddingFunction(MockTextEmbeddingFunction):
    def generate_embeddings(self, texts): # -> list[Any]:
        ...
    


