"""
This type stub file was generated by pyright.
"""

import numpy as np
from typing import List, Optional, TYPE_CHECKING, Union
from .base import TextEmbeddingFunction
from .registry import register

if TYPE_CHECKING:
    ...
@register("ollama")
class OllamaEmbeddings(TextEmbeddingFunction):
    """
    An embedding function that uses Ollama

    https://github.com/ollama/ollama/blob/main/docs/api.md#generate-embeddings
    https://ollama.com/blog/embedding-models
    """
    name: str = ...
    host: str = ...
    options: Optional[dict] = ...
    keep_alive: Optional[Union[float, str]] = ...
    ollama_client_kwargs: Optional[dict] = ...
    def ndims(self): # -> int:
        ...
    
    def generate_embeddings(self, texts: Union[List[str], np.ndarray]) -> list[Union[np.array, None]]:
        """
        Get the embeddings for the given texts

        Parameters
        ----------
        texts: list[str] or np.ndarray (of str)
            The texts to embed
        """
        ...
    


