"""
This type stub file was generated by pyright.
"""

import numpy as np
from typing import List, Optional, TYPE_CHECKING, Union
from .base import TextEmbeddingFunction
from .registry import register

if TYPE_CHECKING:
    ...
@register("openai")
class OpenAIEmbeddings(TextEmbeddingFunction):
    """
    An embedding function that uses the OpenAI API

    https://platform.openai.com/docs/guides/embeddings

    This can also be used for open source models that
    are compatible with the OpenAI API.

    Notes
    -----
    If you're running an Ollama server locally,
    you can just override the `base_url` parameter
    and provide the Ollama embedding model you want
    to use (https://ollama.com/library):

    ```python
    from lancedb.embeddings import get_registry
    openai = get_registry().get("openai")
    embedding_function = openai.create(
        name="<ollama-embedding-model-name>",
        base_url="http://localhost:11434",
        )
    ```

    """
    name: str = ...
    dim: Optional[int] = ...
    base_url: Optional[str] = ...
    default_headers: Optional[dict] = ...
    organization: Optional[str] = ...
    api_key: Optional[str] = ...
    use_azure: bool = ...
    def ndims(self): # -> int:
        ...
    
    @staticmethod
    def sensitive_keys(): # -> list[str]:
        ...
    
    @staticmethod
    def model_names(): # -> list[str]:
        ...
    
    def generate_embeddings(self, texts: Union[List[str], np.ndarray]) -> List[np.array]:
        """
        Get the embeddings for the given texts

        Parameters
        ----------
        texts: list[str] or np.ndarray (of str)
            The texts to embed
        """
        ...
    


