"""
This type stub file was generated by pyright.
"""

import pyarrow as pa
from .base import Reranker

class AnswerdotaiRerankers(Reranker):
    """
    Reranks the results using the Answerdotai Rerank API.
    All supported reranker model types can be found here:
    - https://github.com/AnswerDotAI/rerankers


    Parameters
    ----------
    model_type : str, default "colbert"
        The type of the model to use.
    model_name : str, default "rerank-english-v2.0"
        The name of the model to use from the given model type.
    column : str, default "text"
        The name of the column to use as input to the cross encoder model.
    return_score : str, default "relevance"
        options are "relevance" or "all". Only "relevance" is supported for now.
    **kwargs
        Additional keyword arguments to pass to the model. For example, 'device'.
        See AnswerDotAI/rerankers for more information.
    """
    def __init__(self, model_type=..., model_name: str = ..., column: str = ..., return_score=..., **kwargs) -> None:
        ...
    
    def rerank_hybrid(self, query: str, vector_results: pa.Table, fts_results: pa.Table):
        ...
    
    def rerank_vector(self, query: str, vector_results: pa.Table):
        ...
    
    def rerank_fts(self, query: str, fts_results: pa.Table):
        ...
    


