"""
This type stub file was generated by pyright.
"""

import pyarrow as pa
from typing import Union
from .base import Reranker

class CohereReranker(Reranker):
    """
    Reranks the results using the Cohere Rerank API.
    https://docs.cohere.com/docs/rerank-guide

    Parameters
    ----------
    model_name : str, default "rerank-english-v2.0"
        The name of the cross encoder model to use. Available cohere models are:
        - rerank-english-v2.0
        - rerank-multilingual-v2.0
    column : str, default "text"
        The name of the column to use as input to the cross encoder model.
    top_n : str, default None
        The number of results to return. If None, will return all results.
    """
    def __init__(self, model_name: str = ..., column: str = ..., top_n: Union[int, None] = ..., return_score=..., api_key: Union[str, None] = ...) -> None:
        ...
    
    def rerank_hybrid(self, query: str, vector_results: pa.Table, fts_results: pa.Table):
        ...
    
    def rerank_vector(self, query: str, vector_results: pa.Table):
        ...
    
    def rerank_fts(self, query: str, fts_results: pa.Table):
        ...
    


