"""
This type stub file was generated by pyright.
"""

import pyarrow as pa
from typing import Optional
from .base import Reranker

class OpenaiReranker(Reranker):
    """
    Reranks the results using the OpenAI API.
    WARNING: This is a prompt based reranker that uses chat model that is
    not a dedicated reranker API. This should be treated as experimental.

    Parameters
    ----------
    model_name : str, default "gpt-4-turbo-preview"
        The name of the cross encoder model to use.
    column : str, default "text"
        The name of the column to use as input to the cross encoder model.
    return_score : str, default "relevance"
        options are "relevance" or "all". Only "relevance" is supported for now.
    api_key : str, default None
        The API key to use. If None, will use the OPENAI_API_KEY environment variable.
    """
    def __init__(self, model_name: str = ..., column: str = ..., return_score=..., api_key: Optional[str] = ...) -> None:
        ...
    
    def rerank_hybrid(self, query: str, vector_results: pa.Table, fts_results: pa.Table):
        ...
    
    def rerank_vector(self, query: str, vector_results: pa.Table):
        ...
    
    def rerank_fts(self, query: str, fts_results: pa.Table):
        ...
    


