"""
This type stub file was generated by pyright.
"""

import pyarrow as pa
from typing import Optional
from .base import Reranker

class VoyageAIReranker(Reranker):
    """
    Reranks the results using the VoyageAI Rerank API.
    https://docs.voyageai.com/docs/reranker

    Parameters
    ----------
    model_name : str, default "rerank-english-v2.0"
        The name of the cross encoder model to use. Available voyageai models are:
        - rerank-2
        - rerank-2-lite
    column : str, default "text"
        The name of the column to use as input to the cross encoder model.
    top_n : int, default None
        The number of results to return. If None, will return all results.
    return_score : str, default "relevance"
        options are "relevance" or "all". Only "relevance" is supported for now.
    api_key : str, default None
        The API key to use. If None, will use the OPENAI_API_KEY environment variable.
    truncation : Optional[bool], default None
    """
    def __init__(self, model_name: str, column: str = ..., top_n: Optional[int] = ..., return_score=..., api_key: Optional[str] = ..., truncation: Optional[bool] = ...) -> None:
        ...
    
    def rerank_hybrid(self, query: str, vector_results: pa.Table, fts_results: pa.Table):
        ...
    
    def rerank_vector(self, query: str, vector_results: pa.Table):
        ...
    
    def rerank_fts(self, query: str, fts_results: pa.Table):
        ...
    


