"""
This type stub file was generated by pyright.
"""

from enum import Enum, IntEnum, IntFlag
from typing import Dict, List, Literal, Union
from typing_extensions import NotRequired, TypedDict

"""
This file provides the Python types corresponding to the Typescript types defined in the language server protocol.
This file is obtained from https://github.com/predragnikolic/OLSP under the MIT License with the following terms:

MIT License

Copyright (c) 2023 Предраг Николић

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"""
URI = str
DocumentUri = str
Uint = int
RegExp = str
class SemanticTokenTypes(Enum):
    """A set of predefined token types. This set is not fixed
    an clients can specify additional token types via the
    corresponding client capabilities.

    @since 3.16.0"""
    Namespace = ...
    Type = ...
    Class = ...
    Enum = ...
    Interface = ...
    Struct = ...
    TypeParameter = ...
    Parameter = ...
    Variable = ...
    Property = ...
    EnumMember = ...
    Event = ...
    Function = ...
    Method = ...
    Macro = ...
    Keyword = ...
    Modifier = ...
    Comment = ...
    String = ...
    Number = ...
    Regexp = ...
    Operator = ...
    Decorator = ...


class SemanticTokenModifiers(Enum):
    """A set of predefined token modifiers. This set is not fixed
    an clients can specify additional token types via the
    corresponding client capabilities.

    @since 3.16.0"""
    Declaration = ...
    Definition = ...
    Readonly = ...
    Static = ...
    Deprecated = ...
    Abstract = ...
    Async = ...
    Modification = ...
    Documentation = ...
    DefaultLibrary = ...


class DocumentDiagnosticReportKind(Enum):
    """The document diagnostic report kinds.

    @since 3.17.0"""
    Full = ...
    Unchanged = ...


class ErrorCodes(IntEnum):
    """Predefined error codes."""
    ParseError = ...
    InvalidRequest = ...
    MethodNotFound = ...
    InvalidParams = ...
    InternalError = ...
    ServerNotInitialized = ...
    UnknownErrorCode = ...


class LSPErrorCodes(IntEnum):
    RequestFailed = ...
    ServerCancelled = ...
    ContentModified = ...
    RequestCancelled = ...


class FoldingRangeKind(Enum):
    """A set of predefined range kinds."""
    Comment = ...
    Imports = ...
    Region = ...


class SymbolKind(IntEnum):
    """A symbol kind."""
    File = ...
    Module = ...
    Namespace = ...
    Package = ...
    Class = ...
    Method = ...
    Property = ...
    Field = ...
    Constructor = ...
    Enum = ...
    Interface = ...
    Function = ...
    Variable = ...
    Constant = ...
    String = ...
    Number = ...
    Boolean = ...
    Array = ...
    Object = ...
    Key = ...
    Null = ...
    EnumMember = ...
    Struct = ...
    Event = ...
    Operator = ...
    TypeParameter = ...


class SymbolTag(IntEnum):
    """Symbol tags are extra annotations that tweak the rendering of a symbol.

    @since 3.16"""
    Deprecated = ...


class UniquenessLevel(Enum):
    """Moniker uniqueness level to define scope of the moniker.

    @since 3.16.0"""
    Document = ...
    Project = ...
    Group = ...
    Scheme = ...
    Global = ...


class MonikerKind(Enum):
    """The moniker kind.

    @since 3.16.0"""
    Import = ...
    Export = ...
    Local = ...


class InlayHintKind(IntEnum):
    """Inlay hint kinds.

    @since 3.17.0"""
    Type = ...
    Parameter = ...


class MessageType(IntEnum):
    """The message type"""
    Error = ...
    Warning = ...
    Info = ...
    Log = ...


class TextDocumentSyncKind(IntEnum):
    """Defines how the host (editor) should sync
    document changes to the language server."""
    None_ = ...
    Full = ...
    Incremental = ...


class TextDocumentSaveReason(IntEnum):
    """Represents reasons why a text document is saved."""
    Manual = ...
    AfterDelay = ...
    FocusOut = ...


class CompletionItemKind(IntEnum):
    """The kind of a completion entry."""
    Text = ...
    Method = ...
    Function = ...
    Constructor = ...
    Field = ...
    Variable = ...
    Class = ...
    Interface = ...
    Module = ...
    Property = ...
    Unit = ...
    Value = ...
    Enum = ...
    Keyword = ...
    Snippet = ...
    Color = ...
    File = ...
    Reference = ...
    Folder = ...
    EnumMember = ...
    Constant = ...
    Struct = ...
    Event = ...
    Operator = ...
    TypeParameter = ...


class CompletionItemTag(IntEnum):
    """Completion item tags are extra annotations that tweak the rendering of a completion
    item.

    @since 3.15.0"""
    Deprecated = ...


class InsertTextFormat(IntEnum):
    """Defines whether the insert text in a completion item should be interpreted as
    plain text or a snippet."""
    PlainText = ...
    Snippet = ...


class InsertTextMode(IntEnum):
    """How whitespace and indentation is handled during completion
    item insertion.

    @since 3.16.0"""
    AsIs = ...
    AdjustIndentation = ...


class DocumentHighlightKind(IntEnum):
    """A document highlight kind."""
    Text = ...
    Read = ...
    Write = ...


class CodeActionKind(Enum):
    """A set of predefined code action kinds"""
    Empty = ...
    QuickFix = ...
    Refactor = ...
    RefactorExtract = ...
    RefactorInline = ...
    RefactorRewrite = ...
    Source = ...
    SourceOrganizeImports = ...
    SourceFixAll = ...


class TraceValues(Enum):
    Off = ...
    Messages = ...
    Verbose = ...


class MarkupKind(Enum):
    """Describes the content type that a client supports in various
    result literals like `Hover`, `ParameterInfo` or `CompletionItem`.

    Please note that `MarkupKinds` must not start with a `$`. This kinds
    are reserved for internal usage."""
    PlainText = ...
    Markdown = ...


class PositionEncodingKind(Enum):
    """A set of predefined position encoding kinds.

    @since 3.17.0"""
    UTF8 = ...
    UTF16 = ...
    UTF32 = ...


class FileChangeType(IntEnum):
    """The file event type"""
    Created = ...
    Changed = ...
    Deleted = ...


class WatchKind(IntFlag):
    Create = ...
    Change = ...
    Delete = ...


class DiagnosticSeverity(IntEnum):
    """The diagnostic's severity."""
    Error = ...
    Warning = ...
    Information = ...
    Hint = ...


class DiagnosticTag(IntEnum):
    """The diagnostic tags.

    @since 3.15.0"""
    Unnecessary = ...
    Deprecated = ...


class CompletionTriggerKind(IntEnum):
    """How a completion was triggered"""
    Invoked = ...
    TriggerCharacter = ...
    TriggerForIncompleteCompletions = ...


class SignatureHelpTriggerKind(IntEnum):
    """How a signature help was triggered.

    @since 3.15.0"""
    Invoked = ...
    TriggerCharacter = ...
    ContentChange = ...


class CodeActionTriggerKind(IntEnum):
    """The reason why code actions were requested.

    @since 3.17.0"""
    Invoked = ...
    Automatic = ...


class FileOperationPatternKind(Enum):
    """A pattern kind describing if a glob pattern matches a file a folder or
    both.

    @since 3.16.0"""
    File = ...
    Folder = ...


class NotebookCellKind(IntEnum):
    """A notebook cell kind.

    @since 3.17.0"""
    Markup = ...
    Code = ...


class ResourceOperationKind(Enum):
    Create = ...
    Rename = ...
    Delete = ...


class FailureHandlingKind(Enum):
    Abort = ...
    Transactional = ...
    TextOnlyTransactional = ...
    Undo = ...


class PrepareSupportDefaultBehavior(IntEnum):
    Identifier = ...


class TokenFormat(Enum):
    Relative = ...


Definition = Union["Location", List["Location"]]
DefinitionLink = ...
LSPArray = List["LSPAny"]
LSPAny = Union["LSPObject", "LSPArray", str, int, Uint, float, bool, None]
Declaration = Union["Location", List["Location"]]
DeclarationLink = ...
InlineValue = Union["InlineValueText", "InlineValueVariableLookup", "InlineValueEvaluatableExpression"]
DocumentDiagnosticReport = Union["RelatedFullDocumentDiagnosticReport", "RelatedUnchangedDocumentDiagnosticReport"]
PrepareRenameResult = Union["Range", "__PrepareRenameResult_Type_1", "__PrepareRenameResult_Type_2"]
DocumentSelector = List["DocumentFilter"]
ProgressToken = Union[int, str]
ChangeAnnotationIdentifier = str
WorkspaceDocumentDiagnosticReport = Union["WorkspaceFullDocumentDiagnosticReport", "WorkspaceUnchangedDocumentDiagnosticReport",]
TextDocumentContentChangeEvent = Union["__TextDocumentContentChangeEvent_Type_1", "__TextDocumentContentChangeEvent_Type_2"]
MarkedString = Union[str, "__MarkedString_Type_1"]
DocumentFilter = Union["TextDocumentFilter", "NotebookCellTextDocumentFilter"]
LSPObject = Dict[str, "LSPAny"]
GlobPattern = Union["Pattern", "RelativePattern"]
TextDocumentFilter = Union["__TextDocumentFilter_Type_1", "__TextDocumentFilter_Type_2", "__TextDocumentFilter_Type_3",]
NotebookDocumentFilter = Union["__NotebookDocumentFilter_Type_1", "__NotebookDocumentFilter_Type_2", "__NotebookDocumentFilter_Type_3",]
Pattern = str
class ImplementationParams(TypedDict):
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class Location(TypedDict):
    """Represents a location inside a resource, such as a line
    inside a text file."""
    uri: DocumentUri
    range: Range
    ...


class ImplementationRegistrationOptions(TypedDict):
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class TypeDefinitionParams(TypedDict):
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class TypeDefinitionRegistrationOptions(TypedDict):
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class WorkspaceFolder(TypedDict):
    """A workspace folder inside a client."""
    uri: URI
    name: str
    ...


class DidChangeWorkspaceFoldersParams(TypedDict):
    """The parameters of a `workspace/didChangeWorkspaceFolders` notification."""
    event: WorkspaceFoldersChangeEvent
    ...


class ConfigurationParams(TypedDict):
    """The parameters of a configuration request."""
    items: List[ConfigurationItem]
    ...


class DocumentColorParams(TypedDict):
    """Parameters for a {@link DocumentColorRequest}."""
    textDocument: TextDocumentIdentifier
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class ColorInformation(TypedDict):
    """Represents a color range from a document."""
    range: Range
    color: Color
    ...


class DocumentColorRegistrationOptions(TypedDict):
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class ColorPresentationParams(TypedDict):
    """Parameters for a {@link ColorPresentationRequest}."""
    textDocument: TextDocumentIdentifier
    color: Color
    range: Range
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class ColorPresentation(TypedDict):
    label: str
    textEdit: NotRequired[TextEdit]
    additionalTextEdits: NotRequired[List[TextEdit]]
    ...


class WorkDoneProgressOptions(TypedDict):
    workDoneProgress: NotRequired[bool]
    ...


class TextDocumentRegistrationOptions(TypedDict):
    """General text document registration options."""
    documentSelector: Union[DocumentSelector, None]
    ...


class FoldingRangeParams(TypedDict):
    """Parameters for a {@link FoldingRangeRequest}."""
    textDocument: TextDocumentIdentifier
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class FoldingRange(TypedDict):
    """Represents a folding range. To be valid, start and end line must be bigger than zero and smaller
    than the number of lines in the document. Clients are free to ignore invalid ranges.
    """
    startLine: Uint
    startCharacter: NotRequired[Uint]
    endLine: Uint
    endCharacter: NotRequired[Uint]
    kind: NotRequired[FoldingRangeKind]
    collapsedText: NotRequired[str]
    ...


class FoldingRangeRegistrationOptions(TypedDict):
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class DeclarationParams(TypedDict):
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class DeclarationRegistrationOptions(TypedDict):
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class SelectionRangeParams(TypedDict):
    """A parameter literal used in selection range requests."""
    textDocument: TextDocumentIdentifier
    positions: List[Position]
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class SelectionRange(TypedDict):
    """A selection range represents a part of a selection hierarchy. A selection range
    may have a parent selection range that contains it."""
    range: Range
    parent: NotRequired[SelectionRange]
    ...


class SelectionRangeRegistrationOptions(TypedDict):
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class WorkDoneProgressCreateParams(TypedDict):
    token: ProgressToken
    ...


class WorkDoneProgressCancelParams(TypedDict):
    token: ProgressToken
    ...


class CallHierarchyPrepareParams(TypedDict):
    """The parameter of a `textDocument/prepareCallHierarchy` request.

    @since 3.16.0"""
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    ...


class CallHierarchyItem(TypedDict):
    """Represents programming constructs like functions or constructors in the context
    of call hierarchy.

    @since 3.16.0"""
    name: str
    kind: SymbolKind
    tags: NotRequired[List[SymbolTag]]
    detail: NotRequired[str]
    uri: DocumentUri
    range: Range
    selectionRange: Range
    data: NotRequired[LSPAny]
    ...


class CallHierarchyRegistrationOptions(TypedDict):
    """Call hierarchy options used during static or dynamic registration.

    @since 3.16.0"""
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class CallHierarchyIncomingCallsParams(TypedDict):
    """The parameter of a `callHierarchy/incomingCalls` request.

    @since 3.16.0"""
    item: CallHierarchyItem
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


CallHierarchyIncomingCall = TypedDict("CallHierarchyIncomingCall", { "from": "CallHierarchyItem","fromRanges": List["Range"] })
class CallHierarchyOutgoingCallsParams(TypedDict):
    """The parameter of a `callHierarchy/outgoingCalls` request.

    @since 3.16.0"""
    item: CallHierarchyItem
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class CallHierarchyOutgoingCall(TypedDict):
    """Represents an outgoing call, e.g. calling a getter from a method or a method from a constructor etc.

    @since 3.16.0"""
    to: CallHierarchyItem
    fromRanges: List[Range]
    ...


class SemanticTokensParams(TypedDict):
    """@since 3.16.0"""
    textDocument: TextDocumentIdentifier
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class SemanticTokens(TypedDict):
    """@since 3.16.0"""
    resultId: NotRequired[str]
    data: List[Uint]
    ...


class SemanticTokensPartialResult(TypedDict):
    """@since 3.16.0"""
    data: List[Uint]
    ...


class SemanticTokensRegistrationOptions(TypedDict):
    """@since 3.16.0"""
    documentSelector: Union[DocumentSelector, None]
    legend: SemanticTokensLegend
    range: NotRequired[Union[bool, dict]]
    full: NotRequired[Union[bool, __SemanticTokensOptions_full_Type_1]]
    id: NotRequired[str]
    ...


class SemanticTokensDeltaParams(TypedDict):
    """@since 3.16.0"""
    textDocument: TextDocumentIdentifier
    previousResultId: str
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class SemanticTokensDelta(TypedDict):
    """@since 3.16.0"""
    resultId: NotRequired[str]
    edits: List[SemanticTokensEdit]
    ...


class SemanticTokensDeltaPartialResult(TypedDict):
    """@since 3.16.0"""
    edits: List[SemanticTokensEdit]
    ...


class SemanticTokensRangeParams(TypedDict):
    """@since 3.16.0"""
    textDocument: TextDocumentIdentifier
    range: Range
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class ShowDocumentParams(TypedDict):
    """Params to show a document.

    @since 3.16.0"""
    uri: URI
    external: NotRequired[bool]
    takeFocus: NotRequired[bool]
    selection: NotRequired[Range]
    ...


class ShowDocumentResult(TypedDict):
    """The result of a showDocument request.

    @since 3.16.0"""
    success: bool
    ...


class LinkedEditingRangeParams(TypedDict):
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    ...


class LinkedEditingRanges(TypedDict):
    """The result of a linked editing range request.

    @since 3.16.0"""
    ranges: List[Range]
    wordPattern: NotRequired[str]
    ...


class LinkedEditingRangeRegistrationOptions(TypedDict):
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class CreateFilesParams(TypedDict):
    """The parameters sent in notifications/requests for user-initiated creation of
    files.

    @since 3.16.0"""
    files: List[FileCreate]
    ...


class WorkspaceEdit(TypedDict):
    """A workspace edit represents changes to many resources managed in the workspace. The edit
    should either provide `changes` or `documentChanges`. If documentChanges are present
    they are preferred over `changes` if the client can handle versioned document edits.

    Since version 3.13.0 a workspace edit can contain resource operations as well. If resource
    operations are present clients need to execute the operations in the order in which they
    are provided. So a workspace edit for example can consist of the following two changes:
    (1) a create file a.txt and (2) a text document edit which insert text into file a.txt.

    An invalid sequence (e.g. (1) delete file a.txt and (2) insert text into file a.txt) will
    cause failure of the operation. How the client recovers from the failure is described by
    the client capability: `workspace.workspaceEdit.failureHandling`"""
    changes: NotRequired[Dict[DocumentUri, List[TextEdit]]]
    documentChanges: NotRequired[List[Union[TextDocumentEdit, CreateFile, RenameFile, DeleteFile]]]
    changeAnnotations: NotRequired[Dict[ChangeAnnotationIdentifier, ChangeAnnotation]]
    ...


class FileOperationRegistrationOptions(TypedDict):
    """The options to register for file operations.

    @since 3.16.0"""
    filters: List[FileOperationFilter]
    ...


class RenameFilesParams(TypedDict):
    """The parameters sent in notifications/requests for user-initiated renames of
    files.

    @since 3.16.0"""
    files: List[FileRename]
    ...


class DeleteFilesParams(TypedDict):
    """The parameters sent in notifications/requests for user-initiated deletes of
    files.

    @since 3.16.0"""
    files: List[FileDelete]
    ...


class MonikerParams(TypedDict):
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class Moniker(TypedDict):
    """Moniker definition to match LSIF 0.5 moniker definition.

    @since 3.16.0"""
    scheme: str
    identifier: str
    unique: UniquenessLevel
    kind: NotRequired[MonikerKind]
    ...


class MonikerRegistrationOptions(TypedDict):
    documentSelector: Union[DocumentSelector, None]
    ...


class TypeHierarchyPrepareParams(TypedDict):
    """The parameter of a `textDocument/prepareTypeHierarchy` request.

    @since 3.17.0"""
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    ...


class TypeHierarchyItem(TypedDict):
    """@since 3.17.0"""
    name: str
    kind: SymbolKind
    tags: NotRequired[List[SymbolTag]]
    detail: NotRequired[str]
    uri: DocumentUri
    range: Range
    selectionRange: Range
    data: NotRequired[LSPAny]
    ...


class TypeHierarchyRegistrationOptions(TypedDict):
    """Type hierarchy options used during static or dynamic registration.

    @since 3.17.0"""
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class TypeHierarchySupertypesParams(TypedDict):
    """The parameter of a `typeHierarchy/supertypes` request.

    @since 3.17.0"""
    item: TypeHierarchyItem
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class TypeHierarchySubtypesParams(TypedDict):
    """The parameter of a `typeHierarchy/subtypes` request.

    @since 3.17.0"""
    item: TypeHierarchyItem
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class InlineValueParams(TypedDict):
    """A parameter literal used in inline value requests.

    @since 3.17.0"""
    textDocument: TextDocumentIdentifier
    range: Range
    context: InlineValueContext
    workDoneToken: NotRequired[ProgressToken]
    ...


class InlineValueRegistrationOptions(TypedDict):
    """Inline value options used during static or dynamic registration.

    @since 3.17.0"""
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class InlayHintParams(TypedDict):
    """A parameter literal used in inlay hint requests.

    @since 3.17.0"""
    textDocument: TextDocumentIdentifier
    range: Range
    workDoneToken: NotRequired[ProgressToken]
    ...


class InlayHint(TypedDict):
    """Inlay hint information.

    @since 3.17.0"""
    position: Position
    label: Union[str, List[InlayHintLabelPart]]
    kind: NotRequired[InlayHintKind]
    textEdits: NotRequired[List[TextEdit]]
    tooltip: NotRequired[Union[str, MarkupContent]]
    paddingLeft: NotRequired[bool]
    paddingRight: NotRequired[bool]
    data: NotRequired[LSPAny]
    ...


class InlayHintRegistrationOptions(TypedDict):
    """Inlay hint options used during static or dynamic registration.

    @since 3.17.0"""
    resolveProvider: NotRequired[bool]
    documentSelector: Union[DocumentSelector, None]
    id: NotRequired[str]
    ...


class DocumentDiagnosticParams(TypedDict):
    """Parameters of the document diagnostic request.

    @since 3.17.0"""
    textDocument: TextDocumentIdentifier
    identifier: NotRequired[str]
    previousResultId: NotRequired[str]
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class DocumentDiagnosticReportPartialResult(TypedDict):
    """A partial result for a document diagnostic report.

    @since 3.17.0"""
    relatedDocuments: Dict[DocumentUri, Union[FullDocumentDiagnosticReport, UnchangedDocumentDiagnosticReport],]
    ...


class DiagnosticServerCancellationData(TypedDict):
    """Cancellation data returned from a diagnostic request.

    @since 3.17.0"""
    retriggerRequest: bool
    ...


class DiagnosticRegistrationOptions(TypedDict):
    """Diagnostic registration options.

    @since 3.17.0"""
    documentSelector: Union[DocumentSelector, None]
    identifier: NotRequired[str]
    interFileDependencies: bool
    workspaceDiagnostics: bool
    id: NotRequired[str]
    ...


class WorkspaceDiagnosticParams(TypedDict):
    """Parameters of the workspace diagnostic request.

    @since 3.17.0"""
    identifier: NotRequired[str]
    previousResultIds: List[PreviousResultId]
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class WorkspaceDiagnosticReport(TypedDict):
    """A workspace diagnostic report.

    @since 3.17.0"""
    items: List[WorkspaceDocumentDiagnosticReport]
    ...


class WorkspaceDiagnosticReportPartialResult(TypedDict):
    """A partial result for a workspace diagnostic report.

    @since 3.17.0"""
    items: List[WorkspaceDocumentDiagnosticReport]
    ...


class DidOpenNotebookDocumentParams(TypedDict):
    """The params sent in an open notebook document notification.

    @since 3.17.0"""
    notebookDocument: NotebookDocument
    cellTextDocuments: List[TextDocumentItem]
    ...


class DidChangeNotebookDocumentParams(TypedDict):
    """The params sent in a change notebook document notification.

    @since 3.17.0"""
    notebookDocument: VersionedNotebookDocumentIdentifier
    change: NotebookDocumentChangeEvent
    ...


class DidSaveNotebookDocumentParams(TypedDict):
    """The params sent in a save notebook document notification.

    @since 3.17.0"""
    notebookDocument: NotebookDocumentIdentifier
    ...


class DidCloseNotebookDocumentParams(TypedDict):
    """The params sent in a close notebook document notification.

    @since 3.17.0"""
    notebookDocument: NotebookDocumentIdentifier
    cellTextDocuments: List[TextDocumentIdentifier]
    ...


class RegistrationParams(TypedDict):
    registrations: List[Registration]
    ...


class UnregistrationParams(TypedDict):
    unregisterations: List[Unregistration]
    ...


class InitializeParams(TypedDict):
    processId: Union[int, None]
    clientInfo: NotRequired[___InitializeParams_clientInfo_Type_1]
    locale: NotRequired[str]
    rootPath: NotRequired[Union[str, None]]
    rootUri: Union[DocumentUri, None]
    capabilities: ClientCapabilities
    initializationOptions: NotRequired[LSPAny]
    trace: NotRequired[TraceValues]
    workspaceFolders: NotRequired[Union[List[WorkspaceFolder], None]]
    ...


class InitializeResult(TypedDict):
    """The result returned from an initialize request."""
    capabilities: ServerCapabilities
    serverInfo: NotRequired[__InitializeResult_serverInfo_Type_1]
    ...


class InitializeError(TypedDict):
    """The data type of the ResponseError if the
    initialize request fails."""
    retry: bool
    ...


class InitializedParams(TypedDict):
    ...


class DidChangeConfigurationParams(TypedDict):
    """The parameters of a change configuration notification."""
    settings: LSPAny
    ...


class DidChangeConfigurationRegistrationOptions(TypedDict):
    section: NotRequired[Union[str, List[str]]]
    ...


class ShowMessageParams(TypedDict):
    """The parameters of a notification message."""
    type: MessageType
    message: str
    ...


class ShowMessageRequestParams(TypedDict):
    type: MessageType
    message: str
    actions: NotRequired[List[MessageActionItem]]
    ...


class MessageActionItem(TypedDict):
    title: str
    ...


class LogMessageParams(TypedDict):
    """The log message parameters."""
    type: MessageType
    message: str
    ...


class DidOpenTextDocumentParams(TypedDict):
    """The parameters sent in an open text document notification"""
    textDocument: TextDocumentItem
    ...


class DidChangeTextDocumentParams(TypedDict):
    """The change text document notification's parameters."""
    textDocument: VersionedTextDocumentIdentifier
    contentChanges: List[TextDocumentContentChangeEvent]
    ...


class TextDocumentChangeRegistrationOptions(TypedDict):
    """Describe options to be used when registered for text document change events."""
    syncKind: TextDocumentSyncKind
    documentSelector: Union[DocumentSelector, None]
    ...


class DidCloseTextDocumentParams(TypedDict):
    """The parameters sent in a close text document notification"""
    textDocument: TextDocumentIdentifier
    ...


class DidSaveTextDocumentParams(TypedDict):
    """The parameters sent in a save text document notification"""
    textDocument: TextDocumentIdentifier
    text: NotRequired[str]
    ...


class TextDocumentSaveRegistrationOptions(TypedDict):
    """Save registration options."""
    documentSelector: Union[DocumentSelector, None]
    includeText: NotRequired[bool]
    ...


class WillSaveTextDocumentParams(TypedDict):
    """The parameters sent in a will save text document notification."""
    textDocument: TextDocumentIdentifier
    reason: TextDocumentSaveReason
    ...


class TextEdit(TypedDict):
    """A text edit applicable to a text document."""
    range: Range
    newText: str
    ...


class DidChangeWatchedFilesParams(TypedDict):
    """The watched files change notification's parameters."""
    changes: List[FileEvent]
    ...


class DidChangeWatchedFilesRegistrationOptions(TypedDict):
    """Describe options to be used when registered for text document change events."""
    watchers: List[FileSystemWatcher]
    ...


class PublishDiagnosticsParams(TypedDict):
    """The publish diagnostic notification's parameters."""
    uri: DocumentUri
    version: NotRequired[int]
    diagnostics: List[Diagnostic]
    ...


class CompletionParams(TypedDict):
    """Completion parameters"""
    context: NotRequired[CompletionContext]
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class CompletionItem(TypedDict):
    """A completion item represents a text snippet that is
    proposed to complete text that is being typed."""
    label: str
    labelDetails: NotRequired[CompletionItemLabelDetails]
    kind: NotRequired[CompletionItemKind]
    tags: NotRequired[List[CompletionItemTag]]
    detail: NotRequired[str]
    documentation: NotRequired[Union[str, MarkupContent]]
    deprecated: NotRequired[bool]
    preselect: NotRequired[bool]
    sortText: NotRequired[str]
    filterText: NotRequired[str]
    insertText: NotRequired[str]
    insertTextFormat: NotRequired[InsertTextFormat]
    insertTextMode: NotRequired[InsertTextMode]
    textEdit: NotRequired[Union[TextEdit, InsertReplaceEdit]]
    textEditText: NotRequired[str]
    additionalTextEdits: NotRequired[List[TextEdit]]
    commitCharacters: NotRequired[List[str]]
    command: NotRequired[Command]
    data: NotRequired[LSPAny]
    ...


class CompletionList(TypedDict):
    """Represents a collection of {@link CompletionItem completion items} to be presented
    in the editor."""
    isIncomplete: bool
    itemDefaults: NotRequired[__CompletionList_itemDefaults_Type_1]
    items: List[CompletionItem]
    ...


class CompletionRegistrationOptions(TypedDict):
    """Registration options for a {@link CompletionRequest}."""
    documentSelector: Union[DocumentSelector, None]
    triggerCharacters: NotRequired[List[str]]
    allCommitCharacters: NotRequired[List[str]]
    resolveProvider: NotRequired[bool]
    completionItem: NotRequired[__CompletionOptions_completionItem_Type_1]
    ...


class HoverParams(TypedDict):
    """Parameters for a {@link HoverRequest}."""
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    ...


class Hover(TypedDict):
    """The result of a hover request."""
    contents: Union[MarkupContent, MarkedString, List[MarkedString]]
    range: NotRequired[Range]
    ...


class HoverRegistrationOptions(TypedDict):
    """Registration options for a {@link HoverRequest}."""
    documentSelector: Union[DocumentSelector, None]
    ...


class SignatureHelpParams(TypedDict):
    """Parameters for a {@link SignatureHelpRequest}."""
    context: NotRequired[SignatureHelpContext]
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    ...


class SignatureHelp(TypedDict):
    """Signature help represents the signature of something
    callable. There can be multiple signature but only one
    active and only one active parameter."""
    signatures: List[SignatureInformation]
    activeSignature: NotRequired[Uint]
    activeParameter: NotRequired[Uint]
    ...


class SignatureHelpRegistrationOptions(TypedDict):
    """Registration options for a {@link SignatureHelpRequest}."""
    documentSelector: Union[DocumentSelector, None]
    triggerCharacters: NotRequired[List[str]]
    retriggerCharacters: NotRequired[List[str]]
    ...


class DefinitionParams(TypedDict):
    """Parameters for a {@link DefinitionRequest}."""
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class DefinitionRegistrationOptions(TypedDict):
    """Registration options for a {@link DefinitionRequest}."""
    documentSelector: Union[DocumentSelector, None]
    ...


class ReferenceParams(TypedDict):
    """Parameters for a {@link ReferencesRequest}."""
    context: ReferenceContext
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class ReferenceRegistrationOptions(TypedDict):
    """Registration options for a {@link ReferencesRequest}."""
    documentSelector: Union[DocumentSelector, None]
    ...


class DocumentHighlightParams(TypedDict):
    """Parameters for a {@link DocumentHighlightRequest}."""
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class DocumentHighlight(TypedDict):
    """A document highlight is a range inside a text document which deserves
    special attention. Usually a document highlight is visualized by changing
    the background color of its range."""
    range: Range
    kind: NotRequired[DocumentHighlightKind]
    ...


class DocumentHighlightRegistrationOptions(TypedDict):
    """Registration options for a {@link DocumentHighlightRequest}."""
    documentSelector: Union[DocumentSelector, None]
    ...


class DocumentSymbolParams(TypedDict):
    """Parameters for a {@link DocumentSymbolRequest}."""
    textDocument: TextDocumentIdentifier
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class SymbolInformation(TypedDict):
    """Represents information about programming constructs like variables, classes,
    interfaces etc."""
    deprecated: NotRequired[bool]
    location: Location
    name: str
    kind: SymbolKind
    tags: NotRequired[List[SymbolTag]]
    containerName: NotRequired[str]
    ...


class DocumentSymbol(TypedDict):
    """Represents programming constructs like variables, classes, interfaces etc.
    that appear in a document. Document symbols can be hierarchical and they
    have two ranges: one that encloses its definition and one that points to
    its most interesting range, e.g. the range of an identifier."""
    name: str
    detail: NotRequired[str]
    kind: SymbolKind
    tags: NotRequired[List[SymbolTag]]
    deprecated: NotRequired[bool]
    range: Range
    selectionRange: Range
    children: NotRequired[List[DocumentSymbol]]
    ...


class DocumentSymbolRegistrationOptions(TypedDict):
    """Registration options for a {@link DocumentSymbolRequest}."""
    documentSelector: Union[DocumentSelector, None]
    label: NotRequired[str]
    ...


class CodeActionParams(TypedDict):
    """The parameters of a {@link CodeActionRequest}."""
    textDocument: TextDocumentIdentifier
    range: Range
    context: CodeActionContext
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class Command(TypedDict):
    """Represents a reference to a command. Provides a title which
    will be used to represent a command in the UI and, optionally,
    an array of arguments which will be passed to the command handler
    function when invoked."""
    title: str
    command: str
    arguments: NotRequired[List[LSPAny]]
    ...


class CodeAction(TypedDict):
    """A code action represents a change that can be performed in code, e.g. to fix a problem or
    to refactor code.

    A CodeAction must set either `edit` and/or a `command`. If both are supplied, the `edit` is applied first, then the `command` is executed.
    """
    title: str
    kind: NotRequired[CodeActionKind]
    diagnostics: NotRequired[List[Diagnostic]]
    isPreferred: NotRequired[bool]
    disabled: NotRequired[__CodeAction_disabled_Type_1]
    edit: NotRequired[WorkspaceEdit]
    command: NotRequired[Command]
    data: NotRequired[LSPAny]
    ...


class CodeActionRegistrationOptions(TypedDict):
    """Registration options for a {@link CodeActionRequest}."""
    documentSelector: Union[DocumentSelector, None]
    codeActionKinds: NotRequired[List[CodeActionKind]]
    resolveProvider: NotRequired[bool]
    ...


class WorkspaceSymbolParams(TypedDict):
    """The parameters of a {@link WorkspaceSymbolRequest}."""
    query: str
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class WorkspaceSymbol(TypedDict):
    """A special workspace symbol that supports locations without a range.

    See also SymbolInformation.

    @since 3.17.0"""
    location: Union[Location, __WorkspaceSymbol_location_Type_1]
    data: NotRequired[LSPAny]
    name: str
    kind: SymbolKind
    tags: NotRequired[List[SymbolTag]]
    containerName: NotRequired[str]
    ...


class WorkspaceSymbolRegistrationOptions(TypedDict):
    """Registration options for a {@link WorkspaceSymbolRequest}."""
    resolveProvider: NotRequired[bool]
    ...


class CodeLensParams(TypedDict):
    """The parameters of a {@link CodeLensRequest}."""
    textDocument: TextDocumentIdentifier
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class CodeLens(TypedDict):
    """A code lens represents a {@link Command command} that should be shown along with
    source text, like the number of references, a way to run tests, etc.

    A code lens is _unresolved_ when no command is associated to it. For performance
    reasons the creation of a code lens and resolving should be done in two stages."""
    range: Range
    command: NotRequired[Command]
    data: NotRequired[LSPAny]
    ...


class CodeLensRegistrationOptions(TypedDict):
    """Registration options for a {@link CodeLensRequest}."""
    documentSelector: Union[DocumentSelector, None]
    resolveProvider: NotRequired[bool]
    ...


class DocumentLinkParams(TypedDict):
    """The parameters of a {@link DocumentLinkRequest}."""
    textDocument: TextDocumentIdentifier
    workDoneToken: NotRequired[ProgressToken]
    partialResultToken: NotRequired[ProgressToken]
    ...


class DocumentLink(TypedDict):
    """A document link is a range in a text document that links to an internal or external resource, like another
    text document or a web site."""
    range: Range
    target: NotRequired[str]
    tooltip: NotRequired[str]
    data: NotRequired[LSPAny]
    ...


class DocumentLinkRegistrationOptions(TypedDict):
    """Registration options for a {@link DocumentLinkRequest}."""
    documentSelector: Union[DocumentSelector, None]
    resolveProvider: NotRequired[bool]
    ...


class DocumentFormattingParams(TypedDict):
    """The parameters of a {@link DocumentFormattingRequest}."""
    textDocument: TextDocumentIdentifier
    options: FormattingOptions
    workDoneToken: NotRequired[ProgressToken]
    ...


class DocumentFormattingRegistrationOptions(TypedDict):
    """Registration options for a {@link DocumentFormattingRequest}."""
    documentSelector: Union[DocumentSelector, None]
    ...


class DocumentRangeFormattingParams(TypedDict):
    """The parameters of a {@link DocumentRangeFormattingRequest}."""
    textDocument: TextDocumentIdentifier
    range: Range
    options: FormattingOptions
    workDoneToken: NotRequired[ProgressToken]
    ...


class DocumentRangeFormattingRegistrationOptions(TypedDict):
    """Registration options for a {@link DocumentRangeFormattingRequest}."""
    documentSelector: Union[DocumentSelector, None]
    ...


class DocumentOnTypeFormattingParams(TypedDict):
    """The parameters of a {@link DocumentOnTypeFormattingRequest}."""
    textDocument: TextDocumentIdentifier
    position: Position
    ch: str
    options: FormattingOptions
    ...


class DocumentOnTypeFormattingRegistrationOptions(TypedDict):
    """Registration options for a {@link DocumentOnTypeFormattingRequest}."""
    documentSelector: Union[DocumentSelector, None]
    firstTriggerCharacter: str
    moreTriggerCharacter: NotRequired[List[str]]
    ...


class RenameParams(TypedDict):
    """The parameters of a {@link RenameRequest}."""
    textDocument: TextDocumentIdentifier
    position: Position
    newName: str
    workDoneToken: NotRequired[ProgressToken]
    ...


class RenameRegistrationOptions(TypedDict):
    """Registration options for a {@link RenameRequest}."""
    documentSelector: Union[DocumentSelector, None]
    prepareProvider: NotRequired[bool]
    ...


class PrepareRenameParams(TypedDict):
    textDocument: TextDocumentIdentifier
    position: Position
    workDoneToken: NotRequired[ProgressToken]
    ...


class ExecuteCommandParams(TypedDict):
    """The parameters of a {@link ExecuteCommandRequest}."""
    command: str
    arguments: NotRequired[List[LSPAny]]
    workDoneToken: NotRequired[ProgressToken]
    ...


class ExecuteCommandRegistrationOptions(TypedDict):
    """Registration options for a {@link ExecuteCommandRequest}."""
    commands: List[str]
    ...


class ApplyWorkspaceEditParams(TypedDict):
    """The parameters passed via a apply workspace edit request."""
    label: NotRequired[str]
    edit: WorkspaceEdit
    ...


class ApplyWorkspaceEditResult(TypedDict):
    """The result returned from the apply workspace edit request.

    @since 3.17 renamed from ApplyWorkspaceEditResponse"""
    applied: bool
    failureReason: NotRequired[str]
    failedChange: NotRequired[Uint]
    ...


class WorkDoneProgressBegin(TypedDict):
    kind: Literal["begin"]
    title: str
    cancellable: NotRequired[bool]
    message: NotRequired[str]
    percentage: NotRequired[Uint]
    ...


class WorkDoneProgressReport(TypedDict):
    kind: Literal["report"]
    cancellable: NotRequired[bool]
    message: NotRequired[str]
    percentage: NotRequired[Uint]
    ...


class WorkDoneProgressEnd(TypedDict):
    kind: Literal["end"]
    message: NotRequired[str]
    ...


class SetTraceParams(TypedDict):
    value: TraceValues
    ...


class LogTraceParams(TypedDict):
    message: str
    verbose: NotRequired[str]
    ...


class CancelParams(TypedDict):
    id: Union[int, str]
    ...


class ProgressParams(TypedDict):
    token: ProgressToken
    value: LSPAny
    ...


class TextDocumentPositionParams(TypedDict):
    """A parameter literal used in requests to pass a text document and a position inside that
    document."""
    textDocument: TextDocumentIdentifier
    position: Position
    ...


class WorkDoneProgressParams(TypedDict):
    workDoneToken: NotRequired[ProgressToken]
    ...


class PartialResultParams(TypedDict):
    partialResultToken: NotRequired[ProgressToken]
    ...


class LocationLink(TypedDict):
    """Represents the connection of two locations. Provides additional metadata over normal {@link Location locations},
    including an origin range."""
    originSelectionRange: NotRequired[Range]
    targetUri: DocumentUri
    targetRange: Range
    targetSelectionRange: Range
    ...


class Range(TypedDict):
    """A range in a text document expressed as (zero-based) start and end positions.

    If you want to specify a range that contains a line including the line ending
    character(s) then use an end position denoting the start of the next line.
    For example:
    ```ts
    {
        start: { line: 5, character: 23 }
        end : { line 6, character : 0 }
    }
    ```"""
    start: Position
    end: Position
    ...


class ImplementationOptions(TypedDict):
    workDoneProgress: NotRequired[bool]
    ...


class StaticRegistrationOptions(TypedDict):
    """Static registration options to be returned in the initialize
    request."""
    id: NotRequired[str]
    ...


class TypeDefinitionOptions(TypedDict):
    workDoneProgress: NotRequired[bool]
    ...


class WorkspaceFoldersChangeEvent(TypedDict):
    """The workspace folder change event."""
    added: List[WorkspaceFolder]
    removed: List[WorkspaceFolder]
    ...


class ConfigurationItem(TypedDict):
    scopeUri: NotRequired[str]
    section: NotRequired[str]
    ...


class TextDocumentIdentifier(TypedDict):
    """A literal to identify a text document in the client."""
    uri: DocumentUri
    ...


class Color(TypedDict):
    """Represents a color in RGBA space."""
    red: float
    green: float
    blue: float
    alpha: float
    ...


class DocumentColorOptions(TypedDict):
    workDoneProgress: NotRequired[bool]
    ...


class FoldingRangeOptions(TypedDict):
    workDoneProgress: NotRequired[bool]
    ...


class DeclarationOptions(TypedDict):
    workDoneProgress: NotRequired[bool]
    ...


class Position(TypedDict):
    """Position in a text document expressed as zero-based line and character
    offset. Prior to 3.17 the offsets were always based on a UTF-16 string
    representation. So a string of the form `a𐐀b` the character offset of the
    character `a` is 0, the character offset of `𐐀` is 1 and the character
    offset of b is 3 since `𐐀` is represented using two code units in UTF-16.
    Since 3.17 clients and servers can agree on a different string encoding
    representation (e.g. UTF-8). The client announces it's supported encoding
    via the client capability [`general.positionEncodings`](#clientCapabilities).
    The value is an array of position encodings the client supports, with
    decreasing preference (e.g. the encoding at index `0` is the most preferred
    one). To stay backwards compatible the only mandatory encoding is UTF-16
    represented via the string `utf-16`. The server can pick one of the
    encodings offered by the client and signals that encoding back to the
    client via the initialize result's property
    [`capabilities.positionEncoding`](#serverCapabilities). If the string value
    `utf-16` is missing from the client's capability `general.positionEncodings`
    servers can safely assume that the client supports UTF-16. If the server
    omits the position encoding in its initialize result the encoding defaults
    to the string value `utf-16`. Implementation considerations: since the
    conversion from one encoding into another requires the content of the
    file / line the conversion is best done where the file is read which is
    usually on the server side.

    Positions are line end character agnostic. So you can not specify a position
    that denotes `\r|\n` or `\n|` where `|` represents the character offset.

    @since 3.17.0 - support for negotiated position encoding."""
    line: Uint
    character: Uint
    ...


class SelectionRangeOptions(TypedDict):
    workDoneProgress: NotRequired[bool]
    ...


class CallHierarchyOptions(TypedDict):
    """Call hierarchy options used during static registration.

    @since 3.16.0"""
    workDoneProgress: NotRequired[bool]
    ...


class SemanticTokensOptions(TypedDict):
    """@since 3.16.0"""
    legend: SemanticTokensLegend
    range: NotRequired[Union[bool, dict]]
    full: NotRequired[Union[bool, __SemanticTokensOptions_full_Type_2]]
    workDoneProgress: NotRequired[bool]
    ...


class SemanticTokensEdit(TypedDict):
    """@since 3.16.0"""
    start: Uint
    deleteCount: Uint
    data: NotRequired[List[Uint]]
    ...


class LinkedEditingRangeOptions(TypedDict):
    workDoneProgress: NotRequired[bool]
    ...


class FileCreate(TypedDict):
    """Represents information on a file/folder create.

    @since 3.16.0"""
    uri: str
    ...


class TextDocumentEdit(TypedDict):
    """Describes textual changes on a text document. A TextDocumentEdit describes all changes
    on a document version Si and after they are applied move the document to version Si+1.
    So the creator of a TextDocumentEdit doesn't need to sort the array of edits or do any
    kind of ordering. However the edits must be non overlapping."""
    textDocument: OptionalVersionedTextDocumentIdentifier
    edits: List[Union[TextEdit, AnnotatedTextEdit]]
    ...


class CreateFile(TypedDict):
    """Create file operation."""
    kind: Literal["create"]
    uri: DocumentUri
    options: NotRequired[CreateFileOptions]
    annotationId: NotRequired[ChangeAnnotationIdentifier]
    ...


class RenameFile(TypedDict):
    """Rename file operation"""
    kind: Literal["rename"]
    oldUri: DocumentUri
    newUri: DocumentUri
    options: NotRequired[RenameFileOptions]
    annotationId: NotRequired[ChangeAnnotationIdentifier]
    ...


class DeleteFile(TypedDict):
    """Delete file operation"""
    kind: Literal["delete"]
    uri: DocumentUri
    options: NotRequired[DeleteFileOptions]
    annotationId: NotRequired[ChangeAnnotationIdentifier]
    ...


class ChangeAnnotation(TypedDict):
    """Additional information that describes document changes.

    @since 3.16.0"""
    label: str
    needsConfirmation: NotRequired[bool]
    description: NotRequired[str]
    ...


class FileOperationFilter(TypedDict):
    """A filter to describe in which file operation requests or notifications
    the server is interested in receiving.

    @since 3.16.0"""
    scheme: NotRequired[str]
    pattern: FileOperationPattern
    ...


class FileRename(TypedDict):
    """Represents information on a file/folder rename.

    @since 3.16.0"""
    oldUri: str
    newUri: str
    ...


class FileDelete(TypedDict):
    """Represents information on a file/folder delete.

    @since 3.16.0"""
    uri: str
    ...


class MonikerOptions(TypedDict):
    workDoneProgress: NotRequired[bool]
    ...


class TypeHierarchyOptions(TypedDict):
    """Type hierarchy options used during static registration.

    @since 3.17.0"""
    workDoneProgress: NotRequired[bool]
    ...


class InlineValueContext(TypedDict):
    """@since 3.17.0"""
    frameId: int
    stoppedLocation: Range
    ...


class InlineValueText(TypedDict):
    """Provide inline value as text.

    @since 3.17.0"""
    range: Range
    text: str
    ...


class InlineValueVariableLookup(TypedDict):
    """Provide inline value through a variable lookup.
    If only a range is specified, the variable name will be extracted from the underlying document.
    An optional variable name can be used to override the extracted name.

    @since 3.17.0"""
    range: Range
    variableName: NotRequired[str]
    caseSensitiveLookup: bool
    ...


class InlineValueEvaluatableExpression(TypedDict):
    """Provide an inline value through an expression evaluation.
    If only a range is specified, the expression will be extracted from the underlying document.
    An optional expression can be used to override the extracted expression.

    @since 3.17.0"""
    range: Range
    expression: NotRequired[str]
    ...


class InlineValueOptions(TypedDict):
    """Inline value options used during static registration.

    @since 3.17.0"""
    workDoneProgress: NotRequired[bool]
    ...


class InlayHintLabelPart(TypedDict):
    """An inlay hint label part allows for interactive and composite labels
    of inlay hints.

    @since 3.17.0"""
    value: str
    tooltip: NotRequired[Union[str, MarkupContent]]
    location: NotRequired[Location]
    command: NotRequired[Command]
    ...


class MarkupContent(TypedDict):
    """A `MarkupContent` literal represents a string value which content is interpreted base on its
    kind flag. Currently the protocol supports `plaintext` and `markdown` as markup kinds.

    If the kind is `markdown` then the value can contain fenced code blocks like in GitHub issues.
    See https://help.github.com/articles/creating-and-highlighting-code-blocks/#syntax-highlighting

    Here is an example how such a string can be constructed using JavaScript / TypeScript:
    ```ts
    let markdown: MarkdownContent = {
     kind: MarkupKind.Markdown,
     value: [
       '# Header',
       'Some text',
       '```typescript',
       'someCode();',
       '```'
     ].join('\n')
    };
    ```

    *Please Note* that clients might sanitize the return markdown. A client could decide to
    remove HTML from the markdown to avoid script execution."""
    kind: MarkupKind
    value: str
    ...


class InlayHintOptions(TypedDict):
    """Inlay hint options used during static registration.

    @since 3.17.0"""
    resolveProvider: NotRequired[bool]
    workDoneProgress: NotRequired[bool]
    ...


class RelatedFullDocumentDiagnosticReport(TypedDict):
    """A full diagnostic report with a set of related documents.

    @since 3.17.0"""
    relatedDocuments: NotRequired[Dict[DocumentUri, Union[FullDocumentDiagnosticReport, UnchangedDocumentDiagnosticReport],]]
    kind: Literal["full"]
    resultId: NotRequired[str]
    items: List[Diagnostic]
    ...


class RelatedUnchangedDocumentDiagnosticReport(TypedDict):
    """An unchanged diagnostic report with a set of related documents.

    @since 3.17.0"""
    relatedDocuments: NotRequired[Dict[DocumentUri, Union[FullDocumentDiagnosticReport, UnchangedDocumentDiagnosticReport],]]
    kind: Literal["unchanged"]
    resultId: str
    ...


class FullDocumentDiagnosticReport(TypedDict):
    """A diagnostic report with a full set of problems.

    @since 3.17.0"""
    kind: Literal["full"]
    resultId: NotRequired[str]
    items: List[Diagnostic]
    ...


class UnchangedDocumentDiagnosticReport(TypedDict):
    """A diagnostic report indicating that the last returned
    report is still accurate.

    @since 3.17.0"""
    kind: Literal["unchanged"]
    resultId: str
    ...


class DiagnosticOptions(TypedDict):
    """Diagnostic options.

    @since 3.17.0"""
    identifier: NotRequired[str]
    interFileDependencies: bool
    workspaceDiagnostics: bool
    workDoneProgress: NotRequired[bool]
    ...


class PreviousResultId(TypedDict):
    """A previous result id in a workspace pull request.

    @since 3.17.0"""
    uri: DocumentUri
    value: str
    ...


class NotebookDocument(TypedDict):
    """A notebook document.

    @since 3.17.0"""
    uri: URI
    notebookType: str
    version: int
    metadata: NotRequired[LSPObject]
    cells: List[NotebookCell]
    ...


class TextDocumentItem(TypedDict):
    """An item to transfer a text document from the client to the
    server."""
    uri: DocumentUri
    languageId: str
    version: int
    text: str
    ...


class VersionedNotebookDocumentIdentifier(TypedDict):
    """A versioned notebook document identifier.

    @since 3.17.0"""
    version: int
    uri: URI
    ...


class NotebookDocumentChangeEvent(TypedDict):
    """A change event for a notebook document.

    @since 3.17.0"""
    metadata: NotRequired[LSPObject]
    cells: NotRequired[__NotebookDocumentChangeEvent_cells_Type_1]
    ...


class NotebookDocumentIdentifier(TypedDict):
    """A literal to identify a notebook document in the client.

    @since 3.17.0"""
    uri: URI
    ...


class Registration(TypedDict):
    """General parameters to to register for an notification or to register a provider."""
    id: str
    method: str
    registerOptions: NotRequired[LSPAny]
    ...


class Unregistration(TypedDict):
    """General parameters to unregister a request or notification."""
    id: str
    method: str
    ...


class WorkspaceFoldersInitializeParams(TypedDict):
    workspaceFolders: NotRequired[Union[List[WorkspaceFolder], None]]
    ...


class ServerCapabilities(TypedDict):
    """Defines the capabilities provided by a language
    server."""
    positionEncoding: NotRequired[PositionEncodingKind]
    textDocumentSync: NotRequired[Union[TextDocumentSyncOptions, TextDocumentSyncKind]]
    notebookDocumentSync: NotRequired[Union[NotebookDocumentSyncOptions, NotebookDocumentSyncRegistrationOptions]]
    completionProvider: NotRequired[CompletionOptions]
    hoverProvider: NotRequired[Union[bool, HoverOptions]]
    signatureHelpProvider: NotRequired[SignatureHelpOptions]
    declarationProvider: NotRequired[Union[bool, DeclarationOptions, DeclarationRegistrationOptions]]
    definitionProvider: NotRequired[Union[bool, DefinitionOptions]]
    typeDefinitionProvider: NotRequired[Union[bool, TypeDefinitionOptions, TypeDefinitionRegistrationOptions]]
    implementationProvider: NotRequired[Union[bool, ImplementationOptions, ImplementationRegistrationOptions]]
    referencesProvider: NotRequired[Union[bool, ReferenceOptions]]
    documentHighlightProvider: NotRequired[Union[bool, DocumentHighlightOptions]]
    documentSymbolProvider: NotRequired[Union[bool, DocumentSymbolOptions]]
    codeActionProvider: NotRequired[Union[bool, CodeActionOptions]]
    codeLensProvider: NotRequired[CodeLensOptions]
    documentLinkProvider: NotRequired[DocumentLinkOptions]
    colorProvider: NotRequired[Union[bool, DocumentColorOptions, DocumentColorRegistrationOptions]]
    workspaceSymbolProvider: NotRequired[Union[bool, WorkspaceSymbolOptions]]
    documentFormattingProvider: NotRequired[Union[bool, DocumentFormattingOptions]]
    documentRangeFormattingProvider: NotRequired[Union[bool, DocumentRangeFormattingOptions]]
    documentOnTypeFormattingProvider: NotRequired[DocumentOnTypeFormattingOptions]
    renameProvider: NotRequired[Union[bool, RenameOptions]]
    foldingRangeProvider: NotRequired[Union[bool, FoldingRangeOptions, FoldingRangeRegistrationOptions]]
    selectionRangeProvider: NotRequired[Union[bool, SelectionRangeOptions, SelectionRangeRegistrationOptions]]
    executeCommandProvider: NotRequired[ExecuteCommandOptions]
    callHierarchyProvider: NotRequired[Union[bool, CallHierarchyOptions, CallHierarchyRegistrationOptions]]
    linkedEditingRangeProvider: NotRequired[Union[bool, LinkedEditingRangeOptions, LinkedEditingRangeRegistrationOptions]]
    semanticTokensProvider: NotRequired[Union[SemanticTokensOptions, SemanticTokensRegistrationOptions]]
    monikerProvider: NotRequired[Union[bool, MonikerOptions, MonikerRegistrationOptions]]
    typeHierarchyProvider: NotRequired[Union[bool, TypeHierarchyOptions, TypeHierarchyRegistrationOptions]]
    inlineValueProvider: NotRequired[Union[bool, InlineValueOptions, InlineValueRegistrationOptions]]
    inlayHintProvider: NotRequired[Union[bool, InlayHintOptions, InlayHintRegistrationOptions]]
    diagnosticProvider: NotRequired[Union[DiagnosticOptions, DiagnosticRegistrationOptions]]
    workspace: NotRequired[__ServerCapabilities_workspace_Type_1]
    experimental: NotRequired[LSPAny]
    ...


class VersionedTextDocumentIdentifier(TypedDict):
    """A text document identifier to denote a specific version of a text document."""
    version: int
    uri: DocumentUri
    ...


class SaveOptions(TypedDict):
    """Save options."""
    includeText: NotRequired[bool]
    ...


class FileEvent(TypedDict):
    """An event describing a file change."""
    uri: DocumentUri
    type: FileChangeType
    ...


class FileSystemWatcher(TypedDict):
    globPattern: GlobPattern
    kind: NotRequired[WatchKind]
    ...


class Diagnostic(TypedDict):
    """Represents a diagnostic, such as a compiler error or warning. Diagnostic objects
    are only valid in the scope of a resource."""
    range: Range
    severity: NotRequired[DiagnosticSeverity]
    code: NotRequired[Union[int, str]]
    codeDescription: NotRequired[CodeDescription]
    source: NotRequired[str]
    message: str
    tags: NotRequired[List[DiagnosticTag]]
    relatedInformation: NotRequired[List[DiagnosticRelatedInformation]]
    data: NotRequired[LSPAny]
    ...


class CompletionContext(TypedDict):
    """Contains additional information about the context in which a completion request is triggered."""
    triggerKind: CompletionTriggerKind
    triggerCharacter: NotRequired[str]
    ...


class CompletionItemLabelDetails(TypedDict):
    """Additional details for a completion item label.

    @since 3.17.0"""
    detail: NotRequired[str]
    description: NotRequired[str]
    ...


class InsertReplaceEdit(TypedDict):
    """A special text edit to provide an insert and a replace operation.

    @since 3.16.0"""
    newText: str
    insert: Range
    replace: Range
    ...


class CompletionOptions(TypedDict):
    """Completion options."""
    triggerCharacters: NotRequired[List[str]]
    allCommitCharacters: NotRequired[List[str]]
    resolveProvider: NotRequired[bool]
    completionItem: NotRequired[__CompletionOptions_completionItem_Type_2]
    workDoneProgress: NotRequired[bool]
    ...


class HoverOptions(TypedDict):
    """Hover options."""
    workDoneProgress: NotRequired[bool]
    ...


class SignatureHelpContext(TypedDict):
    """Additional information about the context in which a signature help request was triggered.

    @since 3.15.0"""
    triggerKind: SignatureHelpTriggerKind
    triggerCharacter: NotRequired[str]
    isRetrigger: bool
    activeSignatureHelp: NotRequired[SignatureHelp]
    ...


class SignatureInformation(TypedDict):
    """Represents the signature of something callable. A signature
    can have a label, like a function-name, a doc-comment, and
    a set of parameters."""
    label: str
    documentation: NotRequired[Union[str, MarkupContent]]
    parameters: NotRequired[List[ParameterInformation]]
    activeParameter: NotRequired[Uint]
    ...


class SignatureHelpOptions(TypedDict):
    """Server Capabilities for a {@link SignatureHelpRequest}."""
    triggerCharacters: NotRequired[List[str]]
    retriggerCharacters: NotRequired[List[str]]
    workDoneProgress: NotRequired[bool]
    ...


class DefinitionOptions(TypedDict):
    """Server Capabilities for a {@link DefinitionRequest}."""
    workDoneProgress: NotRequired[bool]
    ...


class ReferenceContext(TypedDict):
    """Value-object that contains additional information when
    requesting references."""
    includeDeclaration: bool
    ...


class ReferenceOptions(TypedDict):
    """Reference options."""
    workDoneProgress: NotRequired[bool]
    ...


class DocumentHighlightOptions(TypedDict):
    """Provider options for a {@link DocumentHighlightRequest}."""
    workDoneProgress: NotRequired[bool]
    ...


class BaseSymbolInformation(TypedDict):
    """A base for all symbol information."""
    name: str
    kind: SymbolKind
    tags: NotRequired[List[SymbolTag]]
    containerName: NotRequired[str]
    ...


class DocumentSymbolOptions(TypedDict):
    """Provider options for a {@link DocumentSymbolRequest}."""
    label: NotRequired[str]
    workDoneProgress: NotRequired[bool]
    ...


class CodeActionContext(TypedDict):
    """Contains additional diagnostic information about the context in which
    a {@link CodeActionProvider.provideCodeActions code action} is run."""
    diagnostics: List[Diagnostic]
    only: NotRequired[List[CodeActionKind]]
    triggerKind: NotRequired[CodeActionTriggerKind]
    ...


class CodeActionOptions(TypedDict):
    """Provider options for a {@link CodeActionRequest}."""
    codeActionKinds: NotRequired[List[CodeActionKind]]
    resolveProvider: NotRequired[bool]
    workDoneProgress: NotRequired[bool]
    ...


class WorkspaceSymbolOptions(TypedDict):
    """Server capabilities for a {@link WorkspaceSymbolRequest}."""
    resolveProvider: NotRequired[bool]
    workDoneProgress: NotRequired[bool]
    ...


class CodeLensOptions(TypedDict):
    """Code Lens provider options of a {@link CodeLensRequest}."""
    resolveProvider: NotRequired[bool]
    workDoneProgress: NotRequired[bool]
    ...


class DocumentLinkOptions(TypedDict):
    """Provider options for a {@link DocumentLinkRequest}."""
    resolveProvider: NotRequired[bool]
    workDoneProgress: NotRequired[bool]
    ...


class FormattingOptions(TypedDict):
    """Value-object describing what options formatting should use."""
    tabSize: Uint
    insertSpaces: bool
    trimTrailingWhitespace: NotRequired[bool]
    insertFinalNewline: NotRequired[bool]
    trimFinalNewlines: NotRequired[bool]
    ...


class DocumentFormattingOptions(TypedDict):
    """Provider options for a {@link DocumentFormattingRequest}."""
    workDoneProgress: NotRequired[bool]
    ...


class DocumentRangeFormattingOptions(TypedDict):
    """Provider options for a {@link DocumentRangeFormattingRequest}."""
    workDoneProgress: NotRequired[bool]
    ...


class DocumentOnTypeFormattingOptions(TypedDict):
    """Provider options for a {@link DocumentOnTypeFormattingRequest}."""
    firstTriggerCharacter: str
    moreTriggerCharacter: NotRequired[List[str]]
    ...


class RenameOptions(TypedDict):
    """Provider options for a {@link RenameRequest}."""
    prepareProvider: NotRequired[bool]
    workDoneProgress: NotRequired[bool]
    ...


class ExecuteCommandOptions(TypedDict):
    """The server capabilities of a {@link ExecuteCommandRequest}."""
    commands: List[str]
    workDoneProgress: NotRequired[bool]
    ...


class SemanticTokensLegend(TypedDict):
    """@since 3.16.0"""
    tokenTypes: List[str]
    tokenModifiers: List[str]
    ...


class OptionalVersionedTextDocumentIdentifier(TypedDict):
    """A text document identifier to optionally denote a specific version of a text document."""
    version: Union[int, None]
    uri: DocumentUri
    ...


class AnnotatedTextEdit(TypedDict):
    """A special text edit with an additional change annotation.

    @since 3.16.0."""
    annotationId: ChangeAnnotationIdentifier
    range: Range
    newText: str
    ...


class ResourceOperation(TypedDict):
    """A generic resource operation."""
    kind: str
    annotationId: NotRequired[ChangeAnnotationIdentifier]
    ...


class CreateFileOptions(TypedDict):
    """Options to create a file."""
    overwrite: NotRequired[bool]
    ignoreIfExists: NotRequired[bool]
    ...


class RenameFileOptions(TypedDict):
    """Rename file options"""
    overwrite: NotRequired[bool]
    ignoreIfExists: NotRequired[bool]
    ...


class DeleteFileOptions(TypedDict):
    """Delete file options"""
    recursive: NotRequired[bool]
    ignoreIfNotExists: NotRequired[bool]
    ...


class FileOperationPattern(TypedDict):
    """A pattern to describe in which file operation requests or notifications
    the server is interested in receiving.

    @since 3.16.0"""
    glob: str
    matches: NotRequired[FileOperationPatternKind]
    options: NotRequired[FileOperationPatternOptions]
    ...


class WorkspaceFullDocumentDiagnosticReport(TypedDict):
    """A full document diagnostic report for a workspace diagnostic result.

    @since 3.17.0"""
    uri: DocumentUri
    version: Union[int, None]
    kind: Literal["full"]
    resultId: NotRequired[str]
    items: List[Diagnostic]
    ...


class WorkspaceUnchangedDocumentDiagnosticReport(TypedDict):
    """An unchanged document diagnostic report for a workspace diagnostic result.

    @since 3.17.0"""
    uri: DocumentUri
    version: Union[int, None]
    kind: Literal["unchanged"]
    resultId: str
    ...


class NotebookCell(TypedDict):
    """A notebook cell.

    A cell's document URI must be unique across ALL notebook
    cells and can therefore be used to uniquely identify a
    notebook cell or the cell's text document.

    @since 3.17.0"""
    kind: NotebookCellKind
    document: DocumentUri
    metadata: NotRequired[LSPObject]
    executionSummary: NotRequired[ExecutionSummary]
    ...


class NotebookCellArrayChange(TypedDict):
    """A change describing how to move a `NotebookCell`
    array from state S to S'.

    @since 3.17.0"""
    start: Uint
    deleteCount: Uint
    cells: NotRequired[List[NotebookCell]]
    ...


class ClientCapabilities(TypedDict):
    """Defines the capabilities provided by the client."""
    workspace: NotRequired[WorkspaceClientCapabilities]
    textDocument: NotRequired[TextDocumentClientCapabilities]
    notebookDocument: NotRequired[NotebookDocumentClientCapabilities]
    window: NotRequired[WindowClientCapabilities]
    general: NotRequired[GeneralClientCapabilities]
    experimental: NotRequired[LSPAny]
    ...


class TextDocumentSyncOptions(TypedDict):
    openClose: NotRequired[bool]
    change: NotRequired[TextDocumentSyncKind]
    willSave: NotRequired[bool]
    willSaveWaitUntil: NotRequired[bool]
    save: NotRequired[Union[bool, SaveOptions]]
    ...


class NotebookDocumentSyncOptions(TypedDict):
    """Options specific to a notebook plus its cells
    to be synced to the server.

    If a selector provides a notebook document
    filter but no cell selector all cells of a
    matching notebook document will be synced.

    If a selector provides no notebook document
    filter but only a cell selector all notebook
    document that contain at least one matching
    cell will be synced.

    @since 3.17.0"""
    notebookSelector: List[Union[__NotebookDocumentSyncOptions_notebookSelector_Type_1, __NotebookDocumentSyncOptions_notebookSelector_Type_2,]]
    save: NotRequired[bool]
    ...


class NotebookDocumentSyncRegistrationOptions(TypedDict):
    """Registration options specific to a notebook.

    @since 3.17.0"""
    notebookSelector: List[Union[__NotebookDocumentSyncOptions_notebookSelector_Type_3, __NotebookDocumentSyncOptions_notebookSelector_Type_4,]]
    save: NotRequired[bool]
    id: NotRequired[str]
    ...


class WorkspaceFoldersServerCapabilities(TypedDict):
    supported: NotRequired[bool]
    changeNotifications: NotRequired[Union[str, bool]]
    ...


class FileOperationOptions(TypedDict):
    """Options for notifications/requests for user operations on files.

    @since 3.16.0"""
    didCreate: NotRequired[FileOperationRegistrationOptions]
    willCreate: NotRequired[FileOperationRegistrationOptions]
    didRename: NotRequired[FileOperationRegistrationOptions]
    willRename: NotRequired[FileOperationRegistrationOptions]
    didDelete: NotRequired[FileOperationRegistrationOptions]
    willDelete: NotRequired[FileOperationRegistrationOptions]
    ...


class CodeDescription(TypedDict):
    """Structure to capture a description for an error code.

    @since 3.16.0"""
    href: URI
    ...


class DiagnosticRelatedInformation(TypedDict):
    """Represents a related message and source code location for a diagnostic. This should be
    used to point to code locations that cause or related to a diagnostics, e.g when duplicating
    a symbol in a scope."""
    location: Location
    message: str
    ...


class ParameterInformation(TypedDict):
    """Represents a parameter of a callable-signature. A parameter can
    have a label and a doc-comment."""
    label: Union[str, List[Union[Uint, Uint]]]
    documentation: NotRequired[Union[str, MarkupContent]]
    ...


class NotebookCellTextDocumentFilter(TypedDict):
    """A notebook cell text document filter denotes a cell text
    document by different properties.

    @since 3.17.0"""
    notebook: Union[str, NotebookDocumentFilter]
    language: NotRequired[str]
    ...


class FileOperationPatternOptions(TypedDict):
    """Matching options for the file operation pattern.

    @since 3.16.0"""
    ignoreCase: NotRequired[bool]
    ...


class ExecutionSummary(TypedDict):
    executionOrder: Uint
    success: NotRequired[bool]
    ...


class WorkspaceClientCapabilities(TypedDict):
    """Workspace specific client capabilities."""
    applyEdit: NotRequired[bool]
    workspaceEdit: NotRequired[WorkspaceEditClientCapabilities]
    didChangeConfiguration: NotRequired[DidChangeConfigurationClientCapabilities]
    didChangeWatchedFiles: NotRequired[DidChangeWatchedFilesClientCapabilities]
    symbol: NotRequired[WorkspaceSymbolClientCapabilities]
    executeCommand: NotRequired[ExecuteCommandClientCapabilities]
    workspaceFolders: NotRequired[bool]
    configuration: NotRequired[bool]
    semanticTokens: NotRequired[SemanticTokensWorkspaceClientCapabilities]
    codeLens: NotRequired[CodeLensWorkspaceClientCapabilities]
    fileOperations: NotRequired[FileOperationClientCapabilities]
    inlineValue: NotRequired[InlineValueWorkspaceClientCapabilities]
    inlayHint: NotRequired[InlayHintWorkspaceClientCapabilities]
    diagnostics: NotRequired[DiagnosticWorkspaceClientCapabilities]
    ...


class TextDocumentClientCapabilities(TypedDict):
    """Text document specific client capabilities."""
    synchronization: NotRequired[TextDocumentSyncClientCapabilities]
    completion: NotRequired[CompletionClientCapabilities]
    hover: NotRequired[HoverClientCapabilities]
    signatureHelp: NotRequired[SignatureHelpClientCapabilities]
    declaration: NotRequired[DeclarationClientCapabilities]
    definition: NotRequired[DefinitionClientCapabilities]
    typeDefinition: NotRequired[TypeDefinitionClientCapabilities]
    implementation: NotRequired[ImplementationClientCapabilities]
    references: NotRequired[ReferenceClientCapabilities]
    documentHighlight: NotRequired[DocumentHighlightClientCapabilities]
    documentSymbol: NotRequired[DocumentSymbolClientCapabilities]
    codeAction: NotRequired[CodeActionClientCapabilities]
    codeLens: NotRequired[CodeLensClientCapabilities]
    documentLink: NotRequired[DocumentLinkClientCapabilities]
    colorProvider: NotRequired[DocumentColorClientCapabilities]
    formatting: NotRequired[DocumentFormattingClientCapabilities]
    rangeFormatting: NotRequired[DocumentRangeFormattingClientCapabilities]
    onTypeFormatting: NotRequired[DocumentOnTypeFormattingClientCapabilities]
    rename: NotRequired[RenameClientCapabilities]
    foldingRange: NotRequired[FoldingRangeClientCapabilities]
    selectionRange: NotRequired[SelectionRangeClientCapabilities]
    publishDiagnostics: NotRequired[PublishDiagnosticsClientCapabilities]
    callHierarchy: NotRequired[CallHierarchyClientCapabilities]
    semanticTokens: NotRequired[SemanticTokensClientCapabilities]
    linkedEditingRange: NotRequired[LinkedEditingRangeClientCapabilities]
    moniker: NotRequired[MonikerClientCapabilities]
    typeHierarchy: NotRequired[TypeHierarchyClientCapabilities]
    inlineValue: NotRequired[InlineValueClientCapabilities]
    inlayHint: NotRequired[InlayHintClientCapabilities]
    diagnostic: NotRequired[DiagnosticClientCapabilities]
    ...


class NotebookDocumentClientCapabilities(TypedDict):
    """Capabilities specific to the notebook document support.

    @since 3.17.0"""
    synchronization: NotebookDocumentSyncClientCapabilities
    ...


class WindowClientCapabilities(TypedDict):
    workDoneProgress: NotRequired[bool]
    showMessage: NotRequired[ShowMessageRequestClientCapabilities]
    showDocument: NotRequired[ShowDocumentClientCapabilities]
    ...


class GeneralClientCapabilities(TypedDict):
    """General client capabilities.

    @since 3.16.0"""
    staleRequestSupport: NotRequired[__GeneralClientCapabilities_staleRequestSupport_Type_1]
    regularExpressions: NotRequired[RegularExpressionsClientCapabilities]
    markdown: NotRequired[MarkdownClientCapabilities]
    positionEncodings: NotRequired[List[PositionEncodingKind]]
    ...


class RelativePattern(TypedDict):
    """A relative pattern is a helper to construct glob patterns that are matched
    relatively to a base URI. The common value for a `baseUri` is a workspace
    folder root, but it can be another absolute URI as well.

    @since 3.17.0"""
    baseUri: Union[WorkspaceFolder, URI]
    pattern: Pattern
    ...


class WorkspaceEditClientCapabilities(TypedDict):
    documentChanges: NotRequired[bool]
    resourceOperations: NotRequired[List[ResourceOperationKind]]
    failureHandling: NotRequired[FailureHandlingKind]
    normalizesLineEndings: NotRequired[bool]
    changeAnnotationSupport: NotRequired[__WorkspaceEditClientCapabilities_changeAnnotationSupport_Type_1]
    ...


class DidChangeConfigurationClientCapabilities(TypedDict):
    dynamicRegistration: NotRequired[bool]
    ...


class DidChangeWatchedFilesClientCapabilities(TypedDict):
    dynamicRegistration: NotRequired[bool]
    relativePatternSupport: NotRequired[bool]
    ...


class WorkspaceSymbolClientCapabilities(TypedDict):
    """Client capabilities for a {@link WorkspaceSymbolRequest}."""
    dynamicRegistration: NotRequired[bool]
    symbolKind: NotRequired[__WorkspaceSymbolClientCapabilities_symbolKind_Type_1]
    tagSupport: NotRequired[__WorkspaceSymbolClientCapabilities_tagSupport_Type_1]
    resolveSupport: NotRequired[__WorkspaceSymbolClientCapabilities_resolveSupport_Type_1]
    ...


class ExecuteCommandClientCapabilities(TypedDict):
    """The client capabilities of a {@link ExecuteCommandRequest}."""
    dynamicRegistration: NotRequired[bool]
    ...


class SemanticTokensWorkspaceClientCapabilities(TypedDict):
    """@since 3.16.0"""
    refreshSupport: NotRequired[bool]
    ...


class CodeLensWorkspaceClientCapabilities(TypedDict):
    """@since 3.16.0"""
    refreshSupport: NotRequired[bool]
    ...


class FileOperationClientCapabilities(TypedDict):
    """Capabilities relating to events from file operations by the user in the client.

    These events do not come from the file system, they come from user operations
    like renaming a file in the UI.

    @since 3.16.0"""
    dynamicRegistration: NotRequired[bool]
    didCreate: NotRequired[bool]
    willCreate: NotRequired[bool]
    didRename: NotRequired[bool]
    willRename: NotRequired[bool]
    didDelete: NotRequired[bool]
    willDelete: NotRequired[bool]
    ...


class InlineValueWorkspaceClientCapabilities(TypedDict):
    """Client workspace capabilities specific to inline values.

    @since 3.17.0"""
    refreshSupport: NotRequired[bool]
    ...


class InlayHintWorkspaceClientCapabilities(TypedDict):
    """Client workspace capabilities specific to inlay hints.

    @since 3.17.0"""
    refreshSupport: NotRequired[bool]
    ...


class DiagnosticWorkspaceClientCapabilities(TypedDict):
    """Workspace client capabilities specific to diagnostic pull requests.

    @since 3.17.0"""
    refreshSupport: NotRequired[bool]
    ...


class TextDocumentSyncClientCapabilities(TypedDict):
    dynamicRegistration: NotRequired[bool]
    willSave: NotRequired[bool]
    willSaveWaitUntil: NotRequired[bool]
    didSave: NotRequired[bool]
    ...


class CompletionClientCapabilities(TypedDict):
    """Completion client capabilities"""
    dynamicRegistration: NotRequired[bool]
    completionItem: NotRequired[__CompletionClientCapabilities_completionItem_Type_1]
    completionItemKind: NotRequired[__CompletionClientCapabilities_completionItemKind_Type_1]
    insertTextMode: NotRequired[InsertTextMode]
    contextSupport: NotRequired[bool]
    completionList: NotRequired[__CompletionClientCapabilities_completionList_Type_1]
    ...


class HoverClientCapabilities(TypedDict):
    dynamicRegistration: NotRequired[bool]
    contentFormat: NotRequired[List[MarkupKind]]
    ...


class SignatureHelpClientCapabilities(TypedDict):
    """Client Capabilities for a {@link SignatureHelpRequest}."""
    dynamicRegistration: NotRequired[bool]
    signatureInformation: NotRequired[__SignatureHelpClientCapabilities_signatureInformation_Type_1]
    contextSupport: NotRequired[bool]
    ...


class DeclarationClientCapabilities(TypedDict):
    """@since 3.14.0"""
    dynamicRegistration: NotRequired[bool]
    linkSupport: NotRequired[bool]
    ...


class DefinitionClientCapabilities(TypedDict):
    """Client Capabilities for a {@link DefinitionRequest}."""
    dynamicRegistration: NotRequired[bool]
    linkSupport: NotRequired[bool]
    ...


class TypeDefinitionClientCapabilities(TypedDict):
    """Since 3.6.0"""
    dynamicRegistration: NotRequired[bool]
    linkSupport: NotRequired[bool]
    ...


class ImplementationClientCapabilities(TypedDict):
    """@since 3.6.0"""
    dynamicRegistration: NotRequired[bool]
    linkSupport: NotRequired[bool]
    ...


class ReferenceClientCapabilities(TypedDict):
    """Client Capabilities for a {@link ReferencesRequest}."""
    dynamicRegistration: NotRequired[bool]
    ...


class DocumentHighlightClientCapabilities(TypedDict):
    """Client Capabilities for a {@link DocumentHighlightRequest}."""
    dynamicRegistration: NotRequired[bool]
    ...


class DocumentSymbolClientCapabilities(TypedDict):
    """Client Capabilities for a {@link DocumentSymbolRequest}."""
    dynamicRegistration: NotRequired[bool]
    symbolKind: NotRequired[__DocumentSymbolClientCapabilities_symbolKind_Type_1]
    hierarchicalDocumentSymbolSupport: NotRequired[bool]
    tagSupport: NotRequired[__DocumentSymbolClientCapabilities_tagSupport_Type_1]
    labelSupport: NotRequired[bool]
    ...


class CodeActionClientCapabilities(TypedDict):
    """The Client Capabilities of a {@link CodeActionRequest}."""
    dynamicRegistration: NotRequired[bool]
    codeActionLiteralSupport: NotRequired[__CodeActionClientCapabilities_codeActionLiteralSupport_Type_1]
    isPreferredSupport: NotRequired[bool]
    disabledSupport: NotRequired[bool]
    dataSupport: NotRequired[bool]
    resolveSupport: NotRequired[__CodeActionClientCapabilities_resolveSupport_Type_1]
    honorsChangeAnnotations: NotRequired[bool]
    ...


class CodeLensClientCapabilities(TypedDict):
    """The client capabilities  of a {@link CodeLensRequest}."""
    dynamicRegistration: NotRequired[bool]
    ...


class DocumentLinkClientCapabilities(TypedDict):
    """The client capabilities of a {@link DocumentLinkRequest}."""
    dynamicRegistration: NotRequired[bool]
    tooltipSupport: NotRequired[bool]
    ...


class DocumentColorClientCapabilities(TypedDict):
    dynamicRegistration: NotRequired[bool]
    ...


class DocumentFormattingClientCapabilities(TypedDict):
    """Client capabilities of a {@link DocumentFormattingRequest}."""
    dynamicRegistration: NotRequired[bool]
    ...


class DocumentRangeFormattingClientCapabilities(TypedDict):
    """Client capabilities of a {@link DocumentRangeFormattingRequest}."""
    dynamicRegistration: NotRequired[bool]
    ...


class DocumentOnTypeFormattingClientCapabilities(TypedDict):
    """Client capabilities of a {@link DocumentOnTypeFormattingRequest}."""
    dynamicRegistration: NotRequired[bool]
    ...


class RenameClientCapabilities(TypedDict):
    dynamicRegistration: NotRequired[bool]
    prepareSupport: NotRequired[bool]
    prepareSupportDefaultBehavior: NotRequired[PrepareSupportDefaultBehavior]
    honorsChangeAnnotations: NotRequired[bool]
    ...


class FoldingRangeClientCapabilities(TypedDict):
    dynamicRegistration: NotRequired[bool]
    rangeLimit: NotRequired[Uint]
    lineFoldingOnly: NotRequired[bool]
    foldingRangeKind: NotRequired[__FoldingRangeClientCapabilities_foldingRangeKind_Type_1]
    foldingRange: NotRequired[__FoldingRangeClientCapabilities_foldingRange_Type_1]
    ...


class SelectionRangeClientCapabilities(TypedDict):
    dynamicRegistration: NotRequired[bool]
    ...


class PublishDiagnosticsClientCapabilities(TypedDict):
    """The publish diagnostic client capabilities."""
    relatedInformation: NotRequired[bool]
    tagSupport: NotRequired[__PublishDiagnosticsClientCapabilities_tagSupport_Type_1]
    versionSupport: NotRequired[bool]
    codeDescriptionSupport: NotRequired[bool]
    dataSupport: NotRequired[bool]
    ...


class CallHierarchyClientCapabilities(TypedDict):
    """@since 3.16.0"""
    dynamicRegistration: NotRequired[bool]
    ...


class SemanticTokensClientCapabilities(TypedDict):
    """@since 3.16.0"""
    dynamicRegistration: NotRequired[bool]
    requests: __SemanticTokensClientCapabilities_requests_Type_1
    tokenTypes: List[str]
    tokenModifiers: List[str]
    formats: List[TokenFormat]
    overlappingTokenSupport: NotRequired[bool]
    multilineTokenSupport: NotRequired[bool]
    serverCancelSupport: NotRequired[bool]
    augmentsSyntaxTokens: NotRequired[bool]
    ...


class LinkedEditingRangeClientCapabilities(TypedDict):
    """Client capabilities for the linked editing range request.

    @since 3.16.0"""
    dynamicRegistration: NotRequired[bool]
    ...


class MonikerClientCapabilities(TypedDict):
    """Client capabilities specific to the moniker request.

    @since 3.16.0"""
    dynamicRegistration: NotRequired[bool]
    ...


class TypeHierarchyClientCapabilities(TypedDict):
    """@since 3.17.0"""
    dynamicRegistration: NotRequired[bool]
    ...


class InlineValueClientCapabilities(TypedDict):
    """Client capabilities specific to inline values.

    @since 3.17.0"""
    dynamicRegistration: NotRequired[bool]
    ...


class InlayHintClientCapabilities(TypedDict):
    """Inlay hint client capabilities.

    @since 3.17.0"""
    dynamicRegistration: NotRequired[bool]
    resolveSupport: NotRequired[__InlayHintClientCapabilities_resolveSupport_Type_1]
    ...


class DiagnosticClientCapabilities(TypedDict):
    """Client capabilities specific to diagnostic pull requests.

    @since 3.17.0"""
    dynamicRegistration: NotRequired[bool]
    relatedDocumentSupport: NotRequired[bool]
    ...


class NotebookDocumentSyncClientCapabilities(TypedDict):
    """Notebook specific client capabilities.

    @since 3.17.0"""
    dynamicRegistration: NotRequired[bool]
    executionSummarySupport: NotRequired[bool]
    ...


class ShowMessageRequestClientCapabilities(TypedDict):
    """Show message request client capabilities"""
    messageActionItem: NotRequired[__ShowMessageRequestClientCapabilities_messageActionItem_Type_1]
    ...


class ShowDocumentClientCapabilities(TypedDict):
    """Client capabilities for the showDocument request.

    @since 3.16.0"""
    support: bool
    ...


class RegularExpressionsClientCapabilities(TypedDict):
    """Client capabilities specific to regular expressions.

    @since 3.16.0"""
    engine: str
    version: NotRequired[str]
    ...


class MarkdownClientCapabilities(TypedDict):
    """Client capabilities specific to the used markdown parser.

    @since 3.16.0"""
    parser: str
    version: NotRequired[str]
    allowedTags: NotRequired[List[str]]
    ...


class __CodeActionClientCapabilities_codeActionLiteralSupport_Type_1(TypedDict):
    codeActionKind: __CodeActionClientCapabilities_codeActionLiteralSupport_codeActionKind_Type_1
    ...


class __CodeActionClientCapabilities_codeActionLiteralSupport_codeActionKind_Type_1(TypedDict):
    valueSet: List[CodeActionKind]
    ...


class __CodeActionClientCapabilities_resolveSupport_Type_1(TypedDict):
    properties: List[str]
    ...


class __CodeAction_disabled_Type_1(TypedDict):
    reason: str
    ...


class __CompletionClientCapabilities_completionItemKind_Type_1(TypedDict):
    valueSet: NotRequired[List[CompletionItemKind]]
    ...


class __CompletionClientCapabilities_completionItem_Type_1(TypedDict):
    snippetSupport: NotRequired[bool]
    commitCharactersSupport: NotRequired[bool]
    documentationFormat: NotRequired[List[MarkupKind]]
    deprecatedSupport: NotRequired[bool]
    preselectSupport: NotRequired[bool]
    tagSupport: NotRequired[__CompletionClientCapabilities_completionItem_tagSupport_Type_1]
    insertReplaceSupport: NotRequired[bool]
    resolveSupport: NotRequired[__CompletionClientCapabilities_completionItem_resolveSupport_Type_1]
    insertTextModeSupport: NotRequired[__CompletionClientCapabilities_completionItem_insertTextModeSupport_Type_1]
    labelDetailsSupport: NotRequired[bool]
    ...


class __CompletionClientCapabilities_completionItem_insertTextModeSupport_Type_1(TypedDict):
    valueSet: List[InsertTextMode]
    ...


class __CompletionClientCapabilities_completionItem_resolveSupport_Type_1(TypedDict):
    properties: List[str]
    ...


class __CompletionClientCapabilities_completionItem_tagSupport_Type_1(TypedDict):
    valueSet: List[CompletionItemTag]
    ...


class __CompletionClientCapabilities_completionList_Type_1(TypedDict):
    itemDefaults: NotRequired[List[str]]
    ...


class __CompletionList_itemDefaults_Type_1(TypedDict):
    commitCharacters: NotRequired[List[str]]
    editRange: NotRequired[Union[Range, __CompletionList_itemDefaults_editRange_Type_1]]
    insertTextFormat: NotRequired[InsertTextFormat]
    insertTextMode: NotRequired[InsertTextMode]
    data: NotRequired[LSPAny]
    ...


class __CompletionList_itemDefaults_editRange_Type_1(TypedDict):
    insert: Range
    replace: Range
    ...


class __CompletionOptions_completionItem_Type_1(TypedDict):
    labelDetailsSupport: NotRequired[bool]
    ...


class __CompletionOptions_completionItem_Type_2(TypedDict):
    labelDetailsSupport: NotRequired[bool]
    ...


class __DocumentSymbolClientCapabilities_symbolKind_Type_1(TypedDict):
    valueSet: NotRequired[List[SymbolKind]]
    ...


class __DocumentSymbolClientCapabilities_tagSupport_Type_1(TypedDict):
    valueSet: List[SymbolTag]
    ...


class __FoldingRangeClientCapabilities_foldingRangeKind_Type_1(TypedDict):
    valueSet: NotRequired[List[FoldingRangeKind]]
    ...


class __FoldingRangeClientCapabilities_foldingRange_Type_1(TypedDict):
    collapsedText: NotRequired[bool]
    ...


class __GeneralClientCapabilities_staleRequestSupport_Type_1(TypedDict):
    cancel: bool
    retryOnContentModified: List[str]
    ...


class __InitializeResult_serverInfo_Type_1(TypedDict):
    name: str
    version: NotRequired[str]
    ...


class __InlayHintClientCapabilities_resolveSupport_Type_1(TypedDict):
    properties: List[str]
    ...


class __MarkedString_Type_1(TypedDict):
    language: str
    value: str
    ...


class __NotebookDocumentChangeEvent_cells_Type_1(TypedDict):
    structure: NotRequired[__NotebookDocumentChangeEvent_cells_structure_Type_1]
    data: NotRequired[List[NotebookCell]]
    textContent: NotRequired[List[__NotebookDocumentChangeEvent_cells_textContent_Type_1]]
    ...


class __NotebookDocumentChangeEvent_cells_structure_Type_1(TypedDict):
    array: NotebookCellArrayChange
    didOpen: NotRequired[List[TextDocumentItem]]
    didClose: NotRequired[List[TextDocumentIdentifier]]
    ...


class __NotebookDocumentChangeEvent_cells_textContent_Type_1(TypedDict):
    document: VersionedTextDocumentIdentifier
    changes: List[TextDocumentContentChangeEvent]
    ...


class __NotebookDocumentFilter_Type_1(TypedDict):
    notebookType: str
    scheme: NotRequired[str]
    pattern: NotRequired[str]
    ...


class __NotebookDocumentFilter_Type_2(TypedDict):
    notebookType: NotRequired[str]
    scheme: str
    pattern: NotRequired[str]
    ...


class __NotebookDocumentFilter_Type_3(TypedDict):
    notebookType: NotRequired[str]
    scheme: NotRequired[str]
    pattern: str
    ...


class __NotebookDocumentSyncOptions_notebookSelector_Type_1(TypedDict):
    notebook: Union[str, NotebookDocumentFilter]
    cells: NotRequired[List[__NotebookDocumentSyncOptions_notebookSelector_cells_Type_1]]
    ...


class __NotebookDocumentSyncOptions_notebookSelector_Type_2(TypedDict):
    notebook: NotRequired[Union[str, NotebookDocumentFilter]]
    cells: List[__NotebookDocumentSyncOptions_notebookSelector_cells_Type_2]
    ...


class __NotebookDocumentSyncOptions_notebookSelector_Type_3(TypedDict):
    notebook: Union[str, NotebookDocumentFilter]
    cells: NotRequired[List[__NotebookDocumentSyncOptions_notebookSelector_cells_Type_3]]
    ...


class __NotebookDocumentSyncOptions_notebookSelector_Type_4(TypedDict):
    notebook: NotRequired[Union[str, NotebookDocumentFilter]]
    cells: List[__NotebookDocumentSyncOptions_notebookSelector_cells_Type_4]
    ...


class __NotebookDocumentSyncOptions_notebookSelector_cells_Type_1(TypedDict):
    language: str
    ...


class __NotebookDocumentSyncOptions_notebookSelector_cells_Type_2(TypedDict):
    language: str
    ...


class __NotebookDocumentSyncOptions_notebookSelector_cells_Type_3(TypedDict):
    language: str
    ...


class __NotebookDocumentSyncOptions_notebookSelector_cells_Type_4(TypedDict):
    language: str
    ...


class __PrepareRenameResult_Type_1(TypedDict):
    range: Range
    placeholder: str
    ...


class __PrepareRenameResult_Type_2(TypedDict):
    defaultBehavior: bool
    ...


class __PublishDiagnosticsClientCapabilities_tagSupport_Type_1(TypedDict):
    valueSet: List[DiagnosticTag]
    ...


class __SemanticTokensClientCapabilities_requests_Type_1(TypedDict):
    range: NotRequired[Union[bool, dict]]
    full: NotRequired[Union[bool, __SemanticTokensClientCapabilities_requests_full_Type_1]]
    ...


class __SemanticTokensClientCapabilities_requests_full_Type_1(TypedDict):
    delta: NotRequired[bool]
    ...


class __SemanticTokensOptions_full_Type_1(TypedDict):
    delta: NotRequired[bool]
    ...


class __SemanticTokensOptions_full_Type_2(TypedDict):
    delta: NotRequired[bool]
    ...


class __ServerCapabilities_workspace_Type_1(TypedDict):
    workspaceFolders: NotRequired[WorkspaceFoldersServerCapabilities]
    fileOperations: NotRequired[FileOperationOptions]
    ...


class __ShowMessageRequestClientCapabilities_messageActionItem_Type_1(TypedDict):
    additionalPropertiesSupport: NotRequired[bool]
    ...


class __SignatureHelpClientCapabilities_signatureInformation_Type_1(TypedDict):
    documentationFormat: NotRequired[List[MarkupKind]]
    parameterInformation: NotRequired[__SignatureHelpClientCapabilities_signatureInformation_parameterInformation_Type_1]
    activeParameterSupport: NotRequired[bool]
    ...


class __SignatureHelpClientCapabilities_signatureInformation_parameterInformation_Type_1(TypedDict):
    labelOffsetSupport: NotRequired[bool]
    ...


class __TextDocumentContentChangeEvent_Type_1(TypedDict):
    range: Range
    rangeLength: NotRequired[Uint]
    text: str
    ...


class __TextDocumentContentChangeEvent_Type_2(TypedDict):
    text: str
    ...


class __TextDocumentFilter_Type_1(TypedDict):
    language: str
    scheme: NotRequired[str]
    pattern: NotRequired[str]
    ...


class __TextDocumentFilter_Type_2(TypedDict):
    language: NotRequired[str]
    scheme: str
    pattern: NotRequired[str]
    ...


class __TextDocumentFilter_Type_3(TypedDict):
    language: NotRequired[str]
    scheme: NotRequired[str]
    pattern: str
    ...


class __WorkspaceEditClientCapabilities_changeAnnotationSupport_Type_1(TypedDict):
    groupsOnLabel: NotRequired[bool]
    ...


class __WorkspaceSymbolClientCapabilities_resolveSupport_Type_1(TypedDict):
    properties: List[str]
    ...


class __WorkspaceSymbolClientCapabilities_symbolKind_Type_1(TypedDict):
    valueSet: NotRequired[List[SymbolKind]]
    ...


class __WorkspaceSymbolClientCapabilities_tagSupport_Type_1(TypedDict):
    valueSet: List[SymbolTag]
    ...


class __WorkspaceSymbol_location_Type_1(TypedDict):
    uri: DocumentUri
    ...


class ___InitializeParams_clientInfo_Type_1(TypedDict):
    name: str
    version: NotRequired[str]
    ...


